diff -NaurdbB -xCVS lsqrms-2.0.4b.old/src/matvecutils.c lsqrms-2.0.4b/src/matvecutils.c
--- lsqrms-2.0.4b.old/src/matvecutils.c	Wed Mar 12 17:12:16 EST 2003
+++ lsqrms-2.0.4b/src/matvecutils.c	Sun Feb 24 22:49:50 EST 2008
@@ -443,1019 +298,2041 @@
       + r[2][0] * (r[0][1]*r[1][2] - r[1][1]*r[0][2]);
 
   spur = (rr[0]+rr[2]+rr[5])/3.0;
-  cof = (rr[2]*rr[5] - SQR(rr[4]) + rr[0]*rr[5] -
-         SQR(rr[3]) + rr[0]*rr[2] - SQR(rr[1]))/3.0;
+  cof = (rr[2]*rr[5] - DSQR(rr[4]) + rr[0]*rr[5] -
+         DSQR(rr[3]) + rr[0]*rr[2] - DSQR(rr[1]))/3.0;
 
   sw = solve(e, e0, det, spur, cof);
-  i = matrix(u, t, sw, e, rr, r, sx, sy, npts);
-  d = SQRTABS(e[2]);
+  matrix(u, t, sw, e, rr, r, sx, sy, npts);
+  d = DSQRTABS(e[2]);
   if (det < 0) d = -d;
-  d += SQRTABS(e[1]) + SQRTABS(e[0]);
+  d += DSQRTABS(e[1]) + DSQRTABS(e[0]);
   d = e0-2*d;
-  return SQRTABS(d);
-
-  } /* bestfit */
-
-double rotrans(double **x_str, int size_str, rotate_t u, xlate_t t) {
-
-  int i;
-
-  double xx, yy, zz;
-
-  for(i=0; i<size_str; i++) {
-
-    xx = x_str[1][i]; yy = x_str[2][i]; zz = x_str[3][i]; 
-
-    x_str[1][i] = u[0][0]*xx + u[0][1]*yy + u[0][2]*zz;
-
-    x_str[2][i] = u[1][0]*xx + u[1][1]*yy + u[1][2]*zz;
-
-    x_str[3][i] = u[2][0]*xx + u[2][1]*yy + u[2][2]*zz;
-
-    x_str[1][i] +=  t[0];
-
-    x_str[2][i] +=  t[1];
-
-    x_str[3][i] +=  t[2];
-
-  } /* i */
-
-  return 7;
-
-} /* rotrans */
-
-
-
-int check_eq(int *iina, int *jinb, int *iina_sav, int *jinb_sav, int nentry) {
-
-  int i, ret_sum;
-
-  ret_sum = 0;
-
-  for(i=0; i<=nentry; i++) {
-
-	if( (iina[i] != iina_sav[i]) || (jinb[i] != jinb_sav[i]) ) ret_sum++;
-
-    if(ret_sum) return ret_sum;
-
-  }
-
-  return ret_sum;
-
-} /* check_eq */
-
-
-
-double distrms(CoordType *a, CoordType *b, int npts)
-
-  {
-
-  int i, j;
-
-  double ad, bd, sum;
-
-
-
-  sum = 0.0;
-
-  for (i = 0; i < npts; i++) {
-
-    for (j = 0; j < i; j++) {
-
-      ad = sqrt(SQR(a[i].x-a[j].x) + SQR(a[i].y-a[j].y) +
-
-                 SQR(a[i].z-a[j].z));
-
-      bd = sqrt(SQR(b[i].x-b[j].x) + SQR(b[i].y-b[j].y) +
-
-                 SQR(b[i].z-b[j].z));
-
-      sum += SQR(ad-bd);
-
-      }
-
-    }
-
-  return sqrt(2*sum/(npts*(npts-1)));
-
-} /* distrms */
-
-
-
-char convert321(char *s) {
-
- if(s[0] == 'G' && s[1] == 'L' && s[2] == 'Y') return 'G';   
-
- if(s[0] == 'A' && s[1] == 'L' && s[2] == 'A') return 'A';    
-
- if(s[0] == 'V' && s[1] == 'A' && s[2] == 'L') return 'V';   
-
- if(s[0] == 'L' && s[1] == 'E' && s[2] == 'U') return 'L';    
-
- if(s[0] == 'I' && s[1] == 'L' && s[2] == 'E') return 'I';   
-
- if(s[0] == 'S' && s[1] == 'E' && s[2] == 'R') return 'S';    
-
- if(s[0] == 'T' && s[1] == 'H' && s[2] == 'R') return 'T';   
-
- if(s[0] == 'C' && s[1] == 'Y' && s[2] == 'S') return 'C';    
-
- if(s[0] == 'M' && s[1] == 'E' && s[2] == 'T') return 'M';   
-
- if(s[0] == 'P' && s[1] == 'R' && s[2] == 'O') return 'P';    
-
- if(s[0] == 'A' && s[1] == 'S' && s[2] == 'P') return 'D';   
-
- if(s[0] == 'A' && s[1] == 'S' && s[2] == 'N') return 'N';    
-
- if(s[0] == 'G' && s[1] == 'L' && s[2] == 'U') return 'E';   
-
- if(s[0] == 'G' && s[1] == 'L' && s[2] == 'N') return 'Q';    
-
- if(s[0] == 'L' && s[1] == 'Y' && s[2] == 'S') return 'K';   
-
- if(s[0] == 'A' && s[1] == 'R' && s[2] == 'G') return 'R';    
-
- if(s[0] == 'H' && s[1] == 'I' && s[2] == 'S') return 'H';   
-
- if(s[0] == 'P' && s[1] == 'H' && s[2] == 'E') return 'F';    
-
- if(s[0] == 'T' && s[1] == 'Y' && s[2] == 'R') return 'Y';   
-
- if(s[0] == 'T' && s[1] == 'R' && s[2] == 'P') return 'W';	 
-
- printf("321 convertion did not succeed! \n");
-
- return 'X';
-
-} /* convert321 */
-
-
-
-double blossom62(char a, char b) {
-
-if( a == 'A' && b == 'A' ) return    8 ;
-
-if( a == 'B' && b == 'A' ) return   -4 ;
-
-if( a == 'B' && b == 'B' ) return    8 ;
-
-if( a == 'C' && b == 'A' ) return    0 ;
-
-if( a == 'C' && b == 'B' ) return   -6 ;
-
-if( a == 'C' && b == 'C' ) return   18 ;
-
-if( a == 'D' && b == 'A' ) return   -4 ;
-
-if( a == 'D' && b == 'B' ) return    8 ;
-
-if( a == 'D' && b == 'C' ) return   -6 ;
-
-if( a == 'D' && b == 'D' ) return   12 ;
-
-if( a == 'E' && b == 'A' ) return   -2 ;
-
-if( a == 'E' && b == 'B' ) return    2 ;
-
-if( a == 'E' && b == 'C' ) return   -8 ;
-
-if( a == 'E' && b == 'D' ) return    4 ;
-
-if( a == 'E' && b == 'E' ) return   10 ;
-
-if( a == 'F' && b == 'A' ) return   -4 ;
-
-if( a == 'F' && b == 'B' ) return   -6 ;
-
-if( a == 'F' && b == 'C' ) return   -4 ;
-
-if( a == 'F' && b == 'D' ) return   -6 ;
-
-if( a == 'F' && b == 'E' ) return   -6 ;
-
-if( a == 'F' && b == 'F' ) return   12 ;
-
-if( a == 'G' && b == 'A' ) return    0 ;
-
-if( a == 'G' && b == 'B' ) return   -2 ;
-
-if( a == 'G' && b == 'C' ) return   -6 ;
-
-if( a == 'G' && b == 'D' ) return   -2 ;
-
-if( a == 'G' && b == 'E' ) return   -4 ;
-
-if( a == 'G' && b == 'F' ) return   -6 ;
-
-if( a == 'G' && b == 'G' ) return   12 ;
-
-if( a == 'H' && b == 'A' ) return   -4 ;
-
-if( a == 'H' && b == 'B' ) return    0 ;
-
-if( a == 'H' && b == 'C' ) return   -6 ;
-
-if( a == 'H' && b == 'D' ) return   -2 ;
-
-if( a == 'H' && b == 'E' ) return    0 ;
-
-if( a == 'H' && b == 'F' ) return   -2 ;
-
-if( a == 'H' && b == 'G' ) return   -4 ;
-
-if( a == 'H' && b == 'H' ) return   16 ;
-
-if( a == 'I' && b == 'A' ) return   -2 ;
-
-if( a == 'I' && b == 'B' ) return   -6 ;
-
-if( a == 'I' && b == 'C' ) return   -2 ;
-
-if( a == 'I' && b == 'D' ) return   -6 ;
-
-if( a == 'I' && b == 'E' ) return   -6 ;
-
-if( a == 'I' && b == 'F' ) return    0 ;
-
-if( a == 'I' && b == 'G' ) return   -8 ;
-
-if( a == 'I' && b == 'H' ) return   -6 ;
-
-if( a == 'I' && b == 'I' ) return    8 ;
-
-if( a == 'K' && b == 'A' ) return   -2 ;
-
-if( a == 'K' && b == 'B' ) return    0 ;
-
-if( a == 'K' && b == 'C' ) return   -6 ;
-
-if( a == 'K' && b == 'D' ) return   -2 ;
-
-if( a == 'K' && b == 'E' ) return    2 ;
-
-if( a == 'K' && b == 'F' ) return   -6 ;
-
-if( a == 'K' && b == 'G' ) return   -4 ;
-
-if( a == 'K' && b == 'H' ) return   -2 ;
-
-if( a == 'K' && b == 'I' ) return   -6 ;
-
-if( a == 'K' && b == 'K' ) return   10 ;
-
-if( a == 'L' && b == 'A' ) return   -2 ;
-
-if( a == 'L' && b == 'B' ) return   -8 ;
-
-if( a == 'L' && b == 'C' ) return   -2 ;
-
-if( a == 'L' && b == 'D' ) return   -8 ;
-
-if( a == 'L' && b == 'E' ) return   -6 ;
-
-if( a == 'L' && b == 'F' ) return    0 ;
-
-if( a == 'L' && b == 'G' ) return   -8 ;
-
-if( a == 'L' && b == 'H' ) return   -6 ;
-
-if( a == 'L' && b == 'I' ) return    4 ;
-
-if( a == 'L' && b == 'K' ) return   -4 ;
-
-if( a == 'L' && b == 'L' ) return    8 ;
-
-if( a == 'M' && b == 'A' ) return   -2 ;
-
-if( a == 'M' && b == 'B' ) return   -6 ;
-
-if( a == 'M' && b == 'C' ) return   -2 ;
-
-if( a == 'M' && b == 'D' ) return   -6 ;
-
-if( a == 'M' && b == 'E' ) return   -4 ;
-
-if( a == 'M' && b == 'F' ) return    0 ;
-
-if( a == 'M' && b == 'G' ) return   -6 ;
-
-if( a == 'M' && b == 'H' ) return   -4 ;
-
-if( a == 'M' && b == 'I' ) return    2 ;
-
-if( a == 'M' && b == 'K' ) return   -2 ;
-
-if( a == 'M' && b == 'L' ) return    4 ;
-
-if( a == 'M' && b == 'M' ) return   10 ;
-
-if( a == 'N' && b == 'A' ) return   -4 ;
-
-if( a == 'N' && b == 'B' ) return    6 ;
-
-if( a == 'N' && b == 'C' ) return   -6 ;
-
-if( a == 'N' && b == 'D' ) return    2 ;
-
-if( a == 'N' && b == 'E' ) return    0 ;
-
-if( a == 'N' && b == 'F' ) return   -6 ;
-
-if( a == 'N' && b == 'G' ) return    0 ;
-
-if( a == 'N' && b == 'H' ) return    2 ;
-
-if( a == 'N' && b == 'I' ) return   -6 ;
-
-if( a == 'N' && b == 'K' ) return    0 ;
-
-if( a == 'N' && b == 'L' ) return   -6 ;
-
-if( a == 'N' && b == 'M' ) return   -4 ;
-
-if( a == 'N' && b == 'N' ) return   12 ;
-
-if( a == 'P' && b == 'A' ) return   -2 ;
-
-if( a == 'P' && b == 'B' ) return   -4 ;
-
-if( a == 'P' && b == 'C' ) return   -6 ;
-
-if( a == 'P' && b == 'D' ) return   -2 ;
-
-if( a == 'P' && b == 'E' ) return   -2 ;
-
-if( a == 'P' && b == 'F' ) return   -8 ;
-
-if( a == 'P' && b == 'G' ) return   -4 ;
-
-if( a == 'P' && b == 'H' ) return   -4 ;
-
-if( a == 'P' && b == 'I' ) return   -6 ;
-
-if( a == 'P' && b == 'K' ) return   -2 ;
-
-if( a == 'P' && b == 'L' ) return   -6 ;
-
-if( a == 'P' && b == 'M' ) return   -4 ;
-
-if( a == 'P' && b == 'N' ) return   -4 ;
-
-if( a == 'P' && b == 'P' ) return   14 ;
-
-if( a == 'Q' && b == 'A' ) return   -2 ;
-
-if( a == 'Q' && b == 'B' ) return    0 ;
-
-if( a == 'Q' && b == 'C' ) return   -6 ;
-
-if( a == 'Q' && b == 'D' ) return    0 ;
-
-if( a == 'Q' && b == 'E' ) return    4 ;
-
-if( a == 'Q' && b == 'F' ) return   -6 ;
-
-if( a == 'Q' && b == 'G' ) return   -4 ;
-
-if( a == 'Q' && b == 'H' ) return    0 ;
-
-if( a == 'Q' && b == 'I' ) return   -6 ;
-
-if( a == 'Q' && b == 'K' ) return    2 ;
-
-if( a == 'Q' && b == 'L' ) return   -4 ;
-
-if( a == 'Q' && b == 'M' ) return    0 ;
-
-if( a == 'Q' && b == 'N' ) return    0 ;
-
-if( a == 'Q' && b == 'P' ) return   -2 ;
-
-if( a == 'Q' && b == 'Q' ) return   10 ;
-
-if( a == 'R' && b == 'A' ) return   -2 ;
-
-if( a == 'R' && b == 'B' ) return   -2 ;
-
-if( a == 'R' && b == 'C' ) return   -6 ;
-
-if( a == 'R' && b == 'D' ) return   -4 ;
-
-if( a == 'R' && b == 'E' ) return    0 ;
-
-if( a == 'R' && b == 'F' ) return   -6 ;
-
-if( a == 'R' && b == 'G' ) return   -4 ;
-
-if( a == 'R' && b == 'H' ) return    0 ;
-
-if( a == 'R' && b == 'I' ) return   -6 ;
-
-if( a == 'R' && b == 'K' ) return    4 ;
-
-if( a == 'R' && b == 'L' ) return   -4 ;
-
-if( a == 'R' && b == 'M' ) return   -2 ;
-
-if( a == 'R' && b == 'N' ) return    0 ;
-
-if( a == 'R' && b == 'P' ) return   -4 ;
-
-if( a == 'R' && b == 'Q' ) return    2 ;
-
-if( a == 'R' && b == 'R' ) return   10 ;
-
-if( a == 'S' && b == 'A' ) return    2 ;
-
-if( a == 'S' && b == 'B' ) return    0 ;
-
-if( a == 'S' && b == 'C' ) return   -2 ;
-
-if( a == 'S' && b == 'D' ) return    0 ;
-
-if( a == 'S' && b == 'E' ) return    0 ;
-
-if( a == 'S' && b == 'F' ) return   -4 ;
-
-if( a == 'S' && b == 'G' ) return    0 ;
-
-if( a == 'S' && b == 'H' ) return   -2 ;
-
-if( a == 'S' && b == 'I' ) return   -4 ;
-
-if( a == 'S' && b == 'K' ) return    0 ;
-
-if( a == 'S' && b == 'L' ) return   -4 ;
-
-if( a == 'S' && b == 'M' ) return   -2 ;
-
-if( a == 'S' && b == 'N' ) return    2 ;
-
-if( a == 'S' && b == 'P' ) return   -2 ;
-
-if( a == 'S' && b == 'Q' ) return    0 ;
-
-if( a == 'S' && b == 'R' ) return   -2 ;
-
-if( a == 'S' && b == 'S' ) return    8 ;
-
-if( a == 'T' && b == 'A' ) return    0 ;
-
-if( a == 'T' && b == 'B' ) return   -2 ;
-
-if( a == 'T' && b == 'C' ) return   -2 ;
-
-if( a == 'T' && b == 'D' ) return   -2 ;
-
-if( a == 'T' && b == 'E' ) return   -2 ;
-
-if( a == 'T' && b == 'F' ) return   -4 ;
-
-if( a == 'T' && b == 'G' ) return   -4 ;
-
-if( a == 'T' && b == 'H' ) return   -4 ;
-
-if( a == 'T' && b == 'I' ) return   -2 ;
-
-if( a == 'T' && b == 'K' ) return   -2 ;
-
-if( a == 'T' && b == 'L' ) return   -2 ;
-
-if( a == 'T' && b == 'M' ) return   -2 ;
-
-if( a == 'T' && b == 'N' ) return    0 ;
-
-if( a == 'T' && b == 'P' ) return   -2 ;
-
-if( a == 'T' && b == 'Q' ) return   -2 ;
-
-if( a == 'T' && b == 'R' ) return   -2 ;
-
-if( a == 'T' && b == 'S' ) return    2 ;
-
-if( a == 'T' && b == 'T' ) return   10 ;
-
-if( a == 'V' && b == 'A' ) return    0 ;
-
-if( a == 'V' && b == 'B' ) return   -6 ;
-
-if( a == 'V' && b == 'C' ) return   -2 ;
-
-if( a == 'V' && b == 'D' ) return   -6 ;
-
-if( a == 'V' && b == 'E' ) return   -4 ;
-
-if( a == 'V' && b == 'F' ) return   -2 ;
-
-if( a == 'V' && b == 'G' ) return   -6 ;
-
-if( a == 'V' && b == 'H' ) return   -6 ;
-
-if( a == 'V' && b == 'I' ) return    6 ;
-
-if( a == 'V' && b == 'K' ) return   -4 ;
-
-if( a == 'V' && b == 'L' ) return    2 ;
-
-if( a == 'V' && b == 'M' ) return    2 ;
-
-if( a == 'V' && b == 'N' ) return   -6 ;
-
-if( a == 'V' && b == 'P' ) return   -4 ;
-
-if( a == 'V' && b == 'Q' ) return   -4 ;
-
-if( a == 'V' && b == 'R' ) return   -6 ;
-
-if( a == 'V' && b == 'S' ) return   -4 ;
-
-if( a == 'V' && b == 'T' ) return    0 ;
-
-if( a == 'V' && b == 'V' ) return    8 ;
-
-if( a == 'W' && b == 'A' ) return   -6 ;
-
-if( a == 'W' && b == 'B' ) return   -8 ;
-
-if( a == 'W' && b == 'C' ) return   -4 ;
-
-if( a == 'W' && b == 'D' ) return   -8 ;
-
-if( a == 'W' && b == 'E' ) return   -6 ;
-
-if( a == 'W' && b == 'F' ) return    2 ;
-
-if( a == 'W' && b == 'G' ) return   -4 ;
-
-if( a == 'W' && b == 'H' ) return   -4 ;
-
-if( a == 'W' && b == 'I' ) return   -6 ;
-
-if( a == 'W' && b == 'K' ) return   -6 ;
-
-if( a == 'W' && b == 'L' ) return   -4 ;
-
-if( a == 'W' && b == 'M' ) return   -2 ;
-
-if( a == 'W' && b == 'N' ) return   -8 ;
-
-if( a == 'W' && b == 'P' ) return   -8 ;
-
-if( a == 'W' && b == 'Q' ) return   -4 ;
-
-if( a == 'W' && b == 'R' ) return   -6 ;
-
-if( a == 'W' && b == 'S' ) return   -6 ;
-
-if( a == 'W' && b == 'T' ) return   -4 ;
-
-if( a == 'W' && b == 'V' ) return   -6 ;
-
-if( a == 'W' && b == 'W' ) return   22 ;
-
-if( a == 'X' && b == 'A' ) return    0 ;
-
-if( a == 'X' && b == 'B' ) return   -2 ;
-
-if( a == 'X' && b == 'C' ) return   -4 ;
-
-if( a == 'X' && b == 'D' ) return   -2 ;
-
-if( a == 'X' && b == 'E' ) return   -2 ;
-
-if( a == 'X' && b == 'F' ) return   -2 ;
-
-if( a == 'X' && b == 'G' ) return   -2 ;
-
-if( a == 'X' && b == 'H' ) return   -2 ;
-
-if( a == 'X' && b == 'I' ) return   -2 ;
-
-if( a == 'X' && b == 'K' ) return   -2 ;
-
-if( a == 'X' && b == 'L' ) return   -2 ;
-
-if( a == 'X' && b == 'M' ) return   -2 ;
-
-if( a == 'X' && b == 'N' ) return   -2 ;
-
-if( a == 'X' && b == 'P' ) return   -4 ;
+  return (double)DSQRTABS(d);
+} /* bestfit */
 
-if( a == 'X' && b == 'Q' ) return   -2 ;
+int check_eq(int *iina, int *jinb, int *iina_sav, int *jinb_sav, int nentry) {
+  int i;
 
-if( a == 'X' && b == 'R' ) return   -2 ;
+  for (i=0; i<=nentry; i++) {
+    if ((iina[i] != iina_sav[i]) || (jinb[i] != jinb_sav[i]))
+      return i+1; /* hack to return what was different - Allen */
+  }
 
-if( a == 'X' && b == 'S' ) return    0 ;
+  return 0;
+} /* check_eq */
 
-if( a == 'X' && b == 'T' ) return    0 ;
+double distrms(CoordType *a, CoordType *b, int npts) {
+  int i, j;
+  LDBL ad, bd, sum;
 
-if( a == 'X' && b == 'V' ) return   -2 ;
+  sum = 0.0;
 
-if( a == 'X' && b == 'W' ) return   -4 ;
+  for (i = 0; i < npts; i++) {
+    for (j = 0; j < i; j++) {
+      ad = DSQRT(SQR(a[i].x-a[j].x) + SQR(a[i].y-a[j].y) +
+		 SQR(a[i].z-a[j].z));
+      bd = DSQRT(SQR(b[i].x-b[j].x) + SQR(b[i].y-b[j].y) +
+		 SQR(b[i].z-b[j].z));
 
-if( a == 'X' && b == 'X' ) return   -2 ;
+      sum += DSQR(ad-bd);
+    }
+  }
 
-if( a == 'Y' && b == 'A' ) return   -4 ;
+  return (double)DSQRT(2*sum/(npts*(npts-1)));
+} /* distrms */
 
-if( a == 'Y' && b == 'B' ) return   -6 ;
+double findCM(double **x_str, int Npts, double *Tcm_str) {
+  int i;
+  LDBL SumX=0, SumY=0, SumZ=0;
 
-if( a == 'Y' && b == 'C' ) return   -4 ;
+  for (i=0; i<Npts; i++) {
+    SumX+=x_str[1][i];
+    SumY+=x_str[2][i];
+    SumZ+=x_str[3][i];
+  } /* for(i<Npts) */
 
-if( a == 'Y' && b == 'D' ) return   -6 ;
+  Tcm_str[1] = (double)(SumX/Npts);
+  Tcm_str[2] = (double)(SumY/Npts);
+  Tcm_str[3] = (double)(SumZ/Npts);
 
-if( a == 'Y' && b == 'E' ) return   -4 ;
+  return (double)(SumZ/Npts);
+} /* findCM */
 
-if( a == 'Y' && b == 'F' ) return    6 ;
+double rotrans(double **x_str, int size_str, rotate_t u, xlate_t t) {
+  int i;
+  double xx, yy, zz;
 
-if( a == 'Y' && b == 'G' ) return   -6 ;
+  for (i=0; i<size_str; i++) {
+    xx = x_str[1][i];
+    yy = x_str[2][i];
+    zz = x_str[3][i]; 
 
-if( a == 'Y' && b == 'H' ) return    4 ;
+    x_str[1][i] = u[0][0]*xx + u[0][1]*yy + u[0][2]*zz;
+    x_str[2][i] = u[1][0]*xx + u[1][1]*yy + u[1][2]*zz;
+    x_str[3][i] = u[2][0]*xx + u[2][1]*yy + u[2][2]*zz;
 
-if( a == 'Y' && b == 'I' ) return   -2 ;
+    x_str[1][i] +=  t[0];
+    x_str[2][i] +=  t[1];
+    x_str[3][i] +=  t[2];
+  } /* for (i<size_str) */
 
-if( a == 'Y' && b == 'K' ) return   -4 ;
+  printf("Rotating query: %.10f %.10f %.10f; %.10f %.10f %.10f; %.10f %.10f %.10f\n",
+	 u[0][0],u[0][1],u[0][2],
+	 u[1][0],u[1][1],u[1][2],
+	 u[2][0],u[2][1],u[2][2]);
+  printf("Moving query: %.10f %.10f %.10f\n", t[0], t[1], t[2]);
 
-if( a == 'Y' && b == 'L' ) return   -2 ;
+  return 7;
+} /* rotrans */
 
-if( a == 'Y' && b == 'M' ) return   -2 ;
+static double TRvec(double *TransVec, double **RotMatr, double *Vec) {
+  double x,y,z;
 
-if( a == 'Y' && b == 'N' ) return   -4 ;
+  x = Vec[1];
+  y = Vec[2];
+  z = Vec[3];
 
-if( a == 'Y' && b == 'P' ) return   -6 ;
+  Vec[1] = RotMatr[1][1]*x + RotMatr[1][2]*y + RotMatr[1][3]*z;
+  Vec[2] = RotMatr[2][1]*x + RotMatr[2][2]*y + RotMatr[2][3]*z;
+  Vec[3] = RotMatr[3][1]*x + RotMatr[3][2]*y + RotMatr[3][3]*z;
 
-if( a == 'Y' && b == 'Q' ) return   -2 ;
+  Vec[1] += TransVec[1];
+  Vec[2] += TransVec[2];
+  Vec[3] += TransVec[3];
 
-if( a == 'Y' && b == 'R' ) return   -4 ;
+  return Vec[3];
+}
 
-if( a == 'Y' && b == 'S' ) return   -4 ;
+double TRmoveXYZstruc(double *TransVec, double **RotMatr,
+		      double **x_str, int Npts) {
+  int i;
+  double ret_val;
+  double *tempVec;
 
-if( a == 'Y' && b == 'T' ) return   -4 ;
+  tempVec = dVector(1,3);
 
-if( a == 'Y' && b == 'V' ) return   -2 ;
+  for (i=0; i<Npts; i++) {
+    tempVec[1] = x_str[1][i]; 
+    tempVec[2] = x_str[2][i]; 
+    tempVec[3] = x_str[3][i];
 
-if( a == 'Y' && b == 'W' ) return    4 ;
+    ret_val = TRvec(TransVec, RotMatr, tempVec);
 
-if( a == 'Y' && b == 'X' ) return   -2 ;
+    x_str[1][i] = tempVec[1];
+    x_str[2][i] = tempVec[2];
+    x_str[3][i] = tempVec[3];
+  }
 
-if( a == 'Y' && b == 'Y' ) return   14 ;
+  free_dVector(tempVec,1,3);
 
-if( a == 'Z' && b == 'A' ) return   -2 ;
+  return ret_val;
+} /* TRmoveXYZstruc */
 
-if( a == 'Z' && b == 'B' ) return    2 ;
+int FindMaxXYZDistIdxLast(double **x_str, int Npts) {
+   int i, iMaxDist=0;
+   LDBL MaxDist, dist;
 
-if( a == 'Z' && b == 'C' ) return   -6 ;
+   MaxDist = DSQRT(SQR(x_str[1][0]) + SQR(x_str[2][0]) + SQR(x_str[3][0]));
 
-if( a == 'Z' && b == 'D' ) return    2 ;
+   for (i=1; i<Npts; i++) {
+     dist = DSQRT(SQR(x_str[1][i]) + SQR(x_str[2][i]) + SQR(x_str[3][i]));
+     if (dist > MaxDist) {
+       iMaxDist = i;
+       MaxDist = dist;
+     }
+   }
 
-if( a == 'Z' && b == 'E' ) return    8 ;
+   return iMaxDist;
+} /* FindMaxXYZDistIdxLast */
 
-if( a == 'Z' && b == 'F' ) return   -6 ;
+int FindMaxXYDistIdxLast(double **x_str, int Npts) {
+   int i, iMaxDist=0;
+   LDBL MaxDist, dist;
 
-if( a == 'Z' && b == 'G' ) return   -4 ;
+   MaxDist = DSQRT(SQR(x_str[1][0]) + SQR(x_str[2][0]) );
 
-if( a == 'Z' && b == 'H' ) return    0 ;
+   for (i=1; i<Npts; i++) {
+     dist  = DSQRT(SQR(x_str[1][i]) + SQR(x_str[2][i]) );
+     if (dist > MaxDist) {
+       iMaxDist = i;
+       MaxDist = dist;
+     }
+   }
 
-if( a == 'Z' && b == 'I' ) return   -6 ;
+   return iMaxDist;
+} /* FindMaxXYDistIdxLast */
 
-if( a == 'Z' && b == 'K' ) return    2 ;
+double AlignZ(double x, double y, double z, double *angle_b, double *angle_c) {
+  LDBL tmp_angle_b;
 
-if( a == 'Z' && b == 'L' ) return   -6 ;
+  tmp_angle_b = DATAN(-x/z);
 
-if( a == 'Z' && b == 'M' ) return   -2 ;
+  *angle_b = (double)tmp_angle_b;
 
-if( a == 'Z' && b == 'N' ) return    0 ;
+  *angle_c = (double)DATAN(-y/(z*DCOS(tmp_angle_b)-x*DCOS(tmp_angle_b)));
 
-if( a == 'Z' && b == 'P' ) return   -2 ;
+  return (double)DCOS(tmp_angle_b);
+}
 
-if( a == 'Z' && b == 'Q' ) return    6 ;
+double FormRotMatrZ(double **Rtemp, double angle_a) {
+  Rtemp[1][1] = cos(angle_a);
+  Rtemp[1][2] = sin(angle_a);
+  Rtemp[1][3] = 0.0e0; 
 
-if( a == 'Z' && b == 'R' ) return    0 ;
+  Rtemp[2][1] = -Rtemp[1][2]; /* sin(angle_a) */
+  Rtemp[2][2] = Rtemp[1][1]; /* cos(angle_a) */
+  Rtemp[2][3] = 0.0e0; 
 
-if( a == 'Z' && b == 'S' ) return    0 ;
+  Rtemp[3][1] = 0.0e0;
+  Rtemp[3][2] = 0.0e0;
+  Rtemp[3][3] = 1.0e0;
 
-if( a == 'Z' && b == 'T' ) return   -2 ;
+  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+} /* FormRotMatrZ */
 
-if( a == 'Z' && b == 'V' ) return   -4 ;
+double FormRotMatrY(double **Rtemp, double angle_a) {
+  Rtemp[1][1] = cos(angle_a);
+  Rtemp[1][2] = 0.0e0;
+  Rtemp[1][3] = sin(angle_a); 
 
-if( a == 'Z' && b == 'W' ) return   -6 ;
+  Rtemp[2][1] = 0.0e0;
+  Rtemp[2][2] = 1.0e0;
+  Rtemp[2][3] = 0.0e0; 
 
-if( a == 'Z' && b == 'X' ) return   -2 ;
+  Rtemp[3][1] = -Rtemp[1][3]; /* sin(angle_a) */
+  Rtemp[3][2] = 0.0e0;
+  Rtemp[3][3] = Rtemp[1][1]; /* cos(angle_a) */
 
-if( a == 'Z' && b == 'Y' ) return   -4 ;
+  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+} /* FormRotMatrY */
 
-if( a == 'Z' && b == 'Z' ) return    8 ;
+double FormRotMatrX(double **Rtemp, double angle_a) {
+  Rtemp[1][1] = 1.0e0;
+  Rtemp[1][2] = 0.0e0;
+  Rtemp[1][3] = 0.0e0; 
 
-
+  Rtemp[2][1] = 0.0e0;
+  Rtemp[2][2] = cos(angle_a);
+  Rtemp[2][3] = sin(angle_a); 
 
-  return -8.8;  
+  Rtemp[3][1] = 0.0e0;
+  Rtemp[3][2] = -Rtemp[2][3]; /* sin(angle_a) */
+  Rtemp[3][3] = Rtemp[2][2]; /* cos(angle_a) */
 
-} /* blossom62 */
+  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+} /* FormRotMatrX */
 
-
+/* double MAX2(double a, double b) { */
+/*   if ( a>b ) return a; */
+/*   return b; */
+/* } */
 
-double findCM(double **x_str, int Npts, double *Tcm_str) {
+/* double MIN2(double a, double b) { */
+/*   if ( a<b ) return a; */
+/*   return b; */
+/* } */
 
-  int i;
+/*=====================================================================*/
+/* Returns sum(i=0..n-1, v[3*i]) */
+static LDBL vsumby3(double v[], int n) {
+  LDBL sum;
+  int i;
 
-  double SumX, SumY, SumZ;
+  sum = *v;
+  n--;
+  v += 3;
 
-  SumX=0; SumY=0; SumZ=0;
+  for (i = 0; i < n; i++, v += 3)
+    sum += *v;
 
-  for(i=0; i<Npts; i++) {
+  return sum;
+}
 
-    SumX+=x_str[1][i]; SumY+=x_str[2][i]; SumZ+=x_str[3][i];
+/*=====================================================================*/
+/* Returns sum(i=0..n-1, v[i]^2) */
+static LDBL vsumsqr(double v[], int n) {
+  LDBL sum;
+  int i;
 
-  } /* for */
+  sum = DSQR(*v);
+  n--;
+  v++;
 
-  Tcm_str[1] = SumX/Npts;
+  for (i = 0; i < n; i++, v++)
+    sum += DSQR(*v);
 
-  Tcm_str[2] = SumY/Npts;
+  return sum;
+}
 
-  Tcm_str[3] = SumZ/Npts;
+/*=====================================================================*/
+/* Returns sum(i=0..n-1, a[3*i]*b[3*i]) */
+static LDBL vdotby3(double a[], double b[],  int n) {
+  LDBL sum;
+  int i;
 
-  return SumZ/Npts;
+  sum = (LDBL)(*a) * (LDBL)(*b);
+  n--;
+  a += 3;
+  b += 3;
 
-}
+  for (i = 0; i < n; i++, a += 3, b += 3)
+    sum += (LDBL)(*a) * (LDBL)(*b);
 
-
+  return sum;
+}
 
-double TRvec(double *TransVec, double **RotMatr, double *Vec) {
+/*=====================================================================*/
 
-  double x,y,z;
+/* Translation table from ASTRAL (http://astral.berkeley.edu) - 11/12/04
+  ala a val v phe f pro p met m ile i leu l asp d glu e lys k
+  arg r ser s thr t tyr y his h cys c asn n gln q trp w gly g
+  2as d 3ah h 5hp e acl r aib a alm a alo t aly k arm r asa d
+  asb d ask d asl d asq d aya a bcs c bhd d bmt t bnn a buc c
+  bug l c5c c c6c c ccs c cea c chg a cle l cme c csd a cso c
+  csp c css c csw c cxm m cy1 c cy3 c cyg c cym c cyq c dah f
+  dal a dar r das d dcy c dgl e dgn q dha a dhi h dil i div v
+  dle l dly k dnp a dpn f dpr p dsn s dsp d dth t dtr w dty y
+  dva v efc c fla a fme m ggl e glz g gma e gsc g hac a har r 
+  hic h hip h hmr r hpq f htr w hyp p iil i iyr y kcx k llp k
+  lly k ltr w lym k lyz k maa a men n mhs h mis s mle l mpq g
+  msa g mse m mva v nem h nep h nle l nln l nlp l nmc g oas s
+  ocs c omt m paq y pca e pec c phi f phl f pr3 c prr a ptr y
+  sac s sar g sch c scs c scy c sel s sep s set s shc c shr k
+  soc c sty y sva s tih a tpl w tpo t tpq a trg k tro w tyb y
+  tyq y tys y tyy y agm r gl3 g smc c asx b cgu e csx c glx z
 
-  x = Vec[1]; y = Vec[2]; z = Vec[3]; 
+  Some also added from .raf edits file (those noted as done automatically).
 
-  Vec[1] = RotMatr[1][1]*x + RotMatr[1][2]*y + RotMatr[1][3]*z;
+  pca changed to z due to sometimes being Q (GLN) instead of E (GLU)
 
-  Vec[2] = RotMatr[2][1]*x + RotMatr[2][2]*y + RotMatr[2][3]*z;
+*/
 
-  Vec[3] = RotMatr[3][1]*x + RotMatr[3][2]*y + RotMatr[3][3]*z;
+char convert321(char *s, int warn, int altered) {
+  switch (s[0]) {
 
-  Vec[1] += TransVec[1];
+  case 'A':
+    if (s[1] == 'L') {
+      if (s[2] == 'A') return 'A';
+      if (s[2] == 'O') return 'T';
+      if (s[2] == 'Y') return 'K';
+      break;
+    }
+    if (s[1] == 'R') {
+      if (s[2] == 'G') return 'R';
+      if (s[2] == 'M') return 'R';
+      break;
+    }
+    if (s[1] == 'S') {
+      if (s[2] == 'N') return 'N';
+      if (s[2] == 'X') return 'B';
+      if ((s[2] == 'P') ||
+	  (s[2] == 'A') ||
+	  (s[2] == 'B') ||
+	  (s[2] == 'K') ||
+	  (s[2] == 'L') ||
+	  (s[2] == 'Q'))
+	return 'D';
+      break;
+    }
+    if (s[1] == 'C') {
+      if (s[2] == 'L') return 'R';
+      if (s[2] == 'A') return 'A';
+      if (s[2] == 'Y') return 'G';
+      break;
+    }
+    if (s[1] == 'G' && s[2] == 'M') return 'R';
+    if (s[1] == 'I' && s[2] == 'B') return 'A';
+    if (s[1] == 'Y' && s[2] == 'A') return 'A';
+    if (s[1] == 'A' && s[2] == 'R') return 'R';
+    if (s[1] == 'B' && s[2] == 'A') return 'B';
+    break;
 
-  Vec[2] += TransVec[2];
+  case 'B':
+    if (s[1] == 'C' && s[2] == 'S') return 'C';
+    if (s[1] == 'H' && s[2] == 'D') return 'D';
+    if (s[1] == 'M' && s[2] == 'T') return 'T';
+    if (s[1] == 'N' && s[2] == 'N') return 'A';
+    if (s[1] == 'T') {
+      if (s[2] == 'A') return 'E';
+      if (s[2] == 'C') return 'G';
+      break;
+    }
+    if (s[1] == 'U') {
+      if (s[2] == 'C') return 'C';
+      if (s[2] == 'G') return 'L';
+      break;
+    }
+    break;
 
-  Vec[3] += TransVec[3];
+  case 'C':
+    if (s[1] == 'Y') {
+      if ((s[2] == 'S') ||
+	  (s[2] == '1') ||
+	  (s[2] == '3') ||
+	  (s[2] == 'G') ||
+	  (s[2] == 'M') ||
+	  (s[2] == 'Q'))
+	return 'C';
+      break;
+    }
+    if (s[1] == 'S') {
+      if ((s[2] == 'B') ||
+	  (s[2] == 'E') ||
+	  (s[2] == 'O') ||
+	  (s[2] == 'P') ||
+	  (s[2] == 'S') ||
+	  (s[2] == 'W') ||
+	  (s[2] == 'X'))
+	return 'C';
+      if (s[2] == 'D') return 'A';
+      break;
+    }
+    if (s[1] == 'L') {
+      if ((s[2] == 'B') ||
+	  (s[2] == 'D'))
+	return 'S';
+      if (s[2] == 'E')
+	return 'L';
+      break;
+    }
+    if (s[1] == '5' && s[2] == 'C') return 'C';
+    if (s[1] == '6' && s[2] == 'C') return 'C';
+    if (s[1] == 'A' && s[2] == 'S') return 'C';
+    if (s[1] == 'A' && s[2] == 'Y') return 'C';
+    if (s[1] == 'C' && s[2] == 'S') return 'C';
+    if (s[1] == 'E' && s[2] == 'A') return 'C';
+    if (s[1] == 'G' && s[2] == 'U') return 'E';
+    if (s[1] == 'H' && s[2] == 'G') return 'A';
+    if (s[1] == 'M' && s[2] == 'E') return 'C';
+    if (s[1] == 'X' && s[2] == 'M') return 'M';
+    break;
 
-  return Vec[3];
+  case 'D':
+    if (s[1] == 'A') {
+      if (s[2] == 'H') return 'F';
+      if (s[2] == 'L') return 'A';
+      if (s[2] == 'R') return 'R';
+      if (s[2] == 'S') return 'D';
+      break;
+    }
+    if (s[1] == 'T') {
+      if (s[2] == 'H') return 'T';
+      if (s[2] == 'R') return 'W';
+      if (s[2] == 'Y') return 'Y';
+      break;
+    }
+    if (s[1] == 'C' && s[2] == 'Y') return 'C';
+    if (s[1] == 'G' && s[2] == 'L') return 'E';
+    if (s[1] == 'G' && s[2] == 'N') return 'Q';
+    if (s[1] == 'H' && s[2] == 'A') return 'A';
+    if (s[1] == 'H' && s[2] == 'I') return 'H';
+    if (s[1] == 'I' && s[2] == 'L') return 'I';
+    if (s[1] == 'I' && s[2] == 'V') return 'V';
+    if (s[1] == 'L' && s[2] == 'E') return 'L';
+    if (s[1] == 'L' && s[2] == 'Y') return 'K';
+    if (s[1] == 'N' && s[2] == 'P') return 'A';
+    if (s[1] == 'O' && s[2] == 'H') return 'D';
+    if (s[1] == 'P' && s[2] == 'N') return 'F';
+    if (s[1] == 'P' && s[2] == 'R') return 'P';
+    if (s[1] == 'S' && s[2] == 'N') return 'S';
+    if (s[1] == 'S' && s[2] == 'P') return 'D';
+    if (s[1] == 'V' && s[2] == 'A') return 'V';
+    break;
 
-}
+  case 'F':
+    if (s[1] == 'G' && s[2] == 'L') return 'C';
+    if (s[1] == 'L' && s[2] == 'A') return 'A';
+    if (s[1] == 'M' && s[2] == 'E') return 'M';
+    break;
 
-
+  case 'G':
+    if (s[1] == 'L') {
+      if (s[2] == 'N') return 'Q';    
+      if (s[2] == 'U') return 'E';
+      if (s[2] == 'Y') return 'G';
+      if (s[2] == 'X') return 'Z';
+      if ((s[2] == 'Y') ||
+	  (s[2] == '3') ||
+	  (s[2] == 'Z'))
+	return 'G';
+      break;
+    }
+    if (s[1] == 'G' && s[2] == 'L') return 'E';
+    if (s[1] == 'M' && s[2] == 'A') return 'E';
+    if (s[1] == 'S' && s[2] == 'C') return 'G';
+    break;
 
-double TRmoveXYZstruc(double *TransVec, double **RotMatr, double **x_str, int Npts) {
+  case 'H':
+    if (s[1] == 'I') {
+      if ((s[2] == 'S') ||
+	  (s[2] == 'C') ||
+	  (s[2] == 'P'))
+	return 'H';
+      break;
+    }
+    if (s[1] == 'A' && s[2] == 'C') return 'A';
+    if (s[1] == 'A' && s[2] == 'R') return 'R';
+    if (s[1] == 'M' && s[2] == 'R') return 'R';
+    if (s[1] == 'P' && s[2] == 'Q') return 'F';
+    if (s[1] == 'T' && s[2] == 'R') return 'W';
+    if (s[1] == 'Y' && s[2] == 'P') return 'P';
+    break;
 
-  int i;
+  case 'I':
+    if (s[1] == 'A' && s[2] == 'S') return 'B';
+    if (s[1] == 'I' && s[2] == 'L') return 'I';
+    if (s[1] == 'N' && s[2] == 'I') return 'K';
+    if (s[1] == 'Y' && s[2] == 'R') return 'Y';
+    if (s[1] == 'L' && s[2] == 'E') return 'I';
+    break;
 
-  double ret_val;
+  case 'L':
+    if (s[1] == 'Y') {
+      if ((s[2] == 'S') ||
+	  (s[2] == 'M') ||
+	  (s[2] == 'X') ||
+	  (s[2] == 'Z'))
+	return 'K';
+      break;
+    }
+    if (s[1] == 'E' && s[2] == 'U') return 'L';    
+    if (s[1] == 'L') {
+      if ((s[2] == 'P') ||
+	  (s[2] == 'Y'))
+	return 'K';
+      break;
+    }
+    if (s[1] == 'T' && s[2] == 'R') return 'W';
+    break;
 
-  double *tempVec;
+  case 'M':
+    if (s[1] == 'E' && s[2] == 'T') return 'M';
+    if (s[1] == 'L') {
+      if ((s[2] == 'Y') ||
+	  (s[2] == 'Z'))
+	return 'K';
+      if (s[2] == 'E') return 'L';
+      break;
+    }
+    if (s[1] == '3' && s[2] == 'L') return 'K';
+    if (s[1] == 'A' && s[2] == 'A') return 'A';
+    if (s[1] == 'E' && s[2] == 'N') return 'N';
+    if (s[1] == 'H' && s[2] == 'O') return 'M';
+    if (s[1] == 'H' && s[2] == 'S') return 'H';
+    if (s[1] == 'I' && s[2] == 'S') return 'S';
+    if (s[1] == 'P' && s[2] == 'Q') return 'G';
+    if (s[1] == 'S' && s[2] == 'A') return 'G';
+    if (s[1] == 'S' && s[2] == 'E') return 'M';
+    if (s[1] == 'V' && s[2] == 'A') return 'V';
+    break;
 
-  tempVec = dVector(1,3);
+  case 'N':
+    if (s[1] == 'E') {
+      if ((s[2] == 'M') ||
+	  (s[2] == 'P'))
+	return 'H';
+      break;
+    }
+    if (s[1] == 'L') {
+      if ((s[2] == 'E') ||
+	  (s[2] == 'N') ||
+	  (s[2] == 'P'))
+	return 'L';
+      break;
+    }
+    if (s[1] == 'M' && s[2] == 'C') return 'G';
+    if (s[1] == 'P' && s[2] == 'H') return 'C';
+    break;
 
-  for(i=0; i<Npts; i++) {
+  case 'O':
+    if (s[1] == 'A' && s[2] == 'S') return 'S';
+    if (s[1] == 'C') {
+      if ((s[2] == 'S') ||
+	  (s[2] == 'Y'))
+	return 'C';
+      break;
+    }
+    if (s[1] == 'M' && s[2] == 'T') return 'M';
+    break;
 
-    tempVec[1] = x_str[1][i]; 
+  case 'P':
+    if (s[1] == 'H') {
+      if ((s[2] == 'E') ||
+	  (s[2] == 'I') ||
+	  (s[2] == 'L'))
+	return 'F';
+      break;
+    }
+    if (s[1] == 'R') {
+      if (s[2] == 'O') return 'P';
+      if (s[2] == 'S') return 'P';
+      if (s[2] == '3') return 'C';
+      if (s[2] == 'R') return 'A';
+      break;
+    }
+    if (s[1] == 'A' && s[2] == 'Q') return 'Y';
+    if (s[1] == 'C' && s[2] == 'A') return 'Z';
+    if (s[1] == 'E' && s[2] == 'C') return 'C';
+    if (s[1] == 'T' && s[2] == 'R') return 'Y';
+    if (s[1] == 'Y' && s[2] == 'X') return 'C';
+    break;
 
-	tempVec[2] = x_str[2][i]; 
+  case 'S':
+    if (s[1] == 'E') {
+      if ((s[2] == 'R') ||
+	  (s[2] == 'L') ||
+	  (s[2] == 'P') ||
+	  (s[2] == 'T'))
+	return 'S';
+      break;
+    }
+    if (s[1] == 'C') {
+      if ((s[2] == 'H') ||
+	  (s[2] == 'S') ||
+	  (s[2] == 'Y'))
+	return 'C';
+      break;
+    }
+    if (s[1] == 'B') {
+      if ((s[2] == 'D') ||
+	  (s[2] == 'L'))
+	return 'S';
+      break;
+    }
+    if (s[1] == 'A' && s[2] == 'C') return 'S';
+    if (s[1] == 'A' && s[2] == 'R') return 'G';
+    if (s[1] == 'H' && s[2] == 'C') return 'C';
+    if (s[1] == 'H' && s[2] == 'R') return 'K';
+    if (s[1] == 'M' && s[2] == 'C') return 'C';
+    if (s[1] == 'M' && s[2] == 'E') return 'M';
+    if (s[1] == 'N' && s[2] == 'N') return 'D';
+    if (s[1] == 'O' && s[2] == 'C') return 'C';
+    if (s[1] == 'T' && s[2] == 'Y') return 'Y';
+    if (s[1] == 'V' && s[2] == 'A') return 'S';
+    break;
 
-	tempVec[3] = x_str[3][i];
+  case 'T':
+    if (s[1] == 'Y') {
+      if ((s[2] == 'R') ||
+	  (s[2] == 'B') ||
+	  (s[2] == 'Q') ||
+	  (s[2] == 'S') ||
+	  (s[2] == 'I') ||
+	  (s[2] == 'Y'))
+	return 'Y';
+      break;
+    }
+    if (s[1] == 'R') {
+      if ((s[2] == 'P') ||
+	  (s[2] == 'N') ||
+	  (s[2] == 'O'))
+	return 'W';
+      if (s[2] == 'G') return 'K';
+      break;
+    }
+    if (s[1] == 'H' && s[2] == 'R') return 'T';   
+    if (s[1] == 'P') {
+      if (s[2] == 'L') return 'W';
+      if (s[2] == 'O') return 'T';
+      if (s[2] == 'Q') return 'A';
+      break;
+    }
+    if (s[1] == 'I' && s[2] == 'H') return 'A';
+    break;
 
-    ret_val = TRvec(TransVec, RotMatr, tempVec);
+  default:
+    if (s[0] == 'V' && s[1] == 'A' && s[2] == 'L') return 'V';
+    if (s[0] == '2' && s[1] == 'A' && s[2] == 'S') return 'D';
+    if (s[0] == '3' && s[1] == 'A' && s[2] == 'H') return 'H';
+    if (s[0] == '5' && s[1] == 'H' && s[2] == 'P') return 'E';
+    if (s[0] == 'E' && s[1] == 'F' && s[2] == 'C') return 'C';
+    if (s[0] == 'K' && s[1] == 'C' && s[2] == 'X') return 'K';
+    if (s[0] == 'U' && s[1] == 'N' && s[2] == 'K') return 'X';
+    if (altered && s[0] == '_' && s[1] == '_' && (! isalpha(s[2])))
+      return s[2];
+    break;
+  }
 
-	x_str[1][i] = tempVec[1]; x_str[2][i] = tempVec[2]; x_str[3][i] = tempVec[3];
+  if (warn) {
+    fprintf(stderr, "convert321: conversion of %s did not succeed!\n", s);
+    return 'X';
+  } else
+    return '?';
+} /* convert321 */
 
-  }
+/* from "Amino Acid Exchange Matrices" article, page 826 */
 
-  free_dVector(tempVec,1,3);
+double gonnet_p(char a, char b, int altered, int use_carbonyl) {
+  if (use_carbonyl) {
+    if (isascii(a) != isascii(b))
+      return -1000;
+    else {
+      if (! isascii(a)) {
+	a = toascii(a);
+	b = toascii(b);
+	if (isalpha(a) != isalpha(b))
+	  return -1000;
+      }
+      if (isalpha(a) && isalpha(b)) {
+	if (isupper(a) != isupper(b))
+	  return -1000;
+	else if (islower(a)) {
+	  a = _toupper(a);
+	  b = _toupper(b);
+	}
+      }
+    }
+  }
 
-  return ret_val;
+  if (altered && (! (isalpha(a) && isalpha(b)))) {
+    if (a == b)
+      return 1000;
+    else
+      return -1000;
+  }
 
-}
+  if (a < b) return gonnet_p(b,a,0,0);
 
-
+  if ((a == 'A') && (b == 'A')) return 7.6;
 
-int FindMaxXYZDistIdxLast(double **x_str, int Npts) {
+  if ((a == 'B') && (b == 'A')) return 4.9;
+  if ((a == 'B') && (b == 'B')) return 9.9;
 
-   int i, iMaxDist;
+  if ((a == 'C') && (b == 'A')) return 5.7;
+  if ((a == 'C') && (b == 'B')) return 2.7;
+  if ((a == 'C') && (b == 'C')) return 16.7;
 
-   double MaxDist, dist;
+  if ((a == 'D') && (b == 'A')) return 4.9;
+  if ((a == 'D') && (b == 'B')) return 8.65;
+  if ((a == 'D') && (b == 'C')) return 2;
+  if ((a == 'D') && (b == 'D')) return 9;
 
-   MaxDist  = sqrt( SQR(x_str[1][0]) + SQR(x_str[2][0]) + SQR(x_str[3][0]));
+  if ((a == 'E') && (b == 'A')) return 5.2;
+  if ((a == 'E') && (b == 'B')) return 7;
+  if ((a == 'E') && (b == 'C')) return 2.2;
+  if ((a == 'E') && (b == 'D')) return 7.9;
+  if ((a == 'E') && (b == 'E')) return 8.8;
 
-   iMaxDist = 0;
+  if ((a == 'F') && (b == 'A')) return 2.9;
+  if ((a == 'F') && (b == 'B')) return 1.4;
+  if ((a == 'F') && (b == 'C')) return 4.4;
+  if ((a == 'F') && (b == 'D')) return 0.7;
+  if ((a == 'F') && (b == 'E')) return 1.3;
+  if ((a == 'F') && (b == 'F')) return 12.2;
 
-   for(i=1; i<Npts; i++) {
+  if ((a == 'G') && (b == 'A')) return 5.7;
+  if ((a == 'G') && (b == 'B')) return 5.45;
+  if ((a == 'G') && (b == 'C')) return 3.2;
+  if ((a == 'G') && (b == 'D')) return 5.3;
+  if ((a == 'G') && (b == 'E')) return 4.4;
+  if ((a == 'G') && (b == 'F')) return 0;
+  if ((a == 'G') && (b == 'G')) return 11.8;
 
-     dist  = sqrt( SQR(x_str[1][i]) + SQR(x_str[2][i]) + SQR(x_str[3][i]));
+  if ((a == 'H') && (b == 'A')) return 4.4;
+  if ((a == 'H') && (b == 'B')) return 6;
+  if ((a == 'H') && (b == 'C')) return 3.9;
+  if ((a == 'H') && (b == 'D')) return 5.6;
+  if ((a == 'H') && (b == 'E')) return 5.6;
+  if ((a == 'H') && (b == 'F')) return 5.1;
+  if ((a == 'H') && (b == 'G')) return 3.8;
+  if ((a == 'H') && (b == 'H')) return 11.2;
 
-	 if( dist > MaxDist) {
+  if ((a == 'I') && (b == 'A')) return 4.4;
+  if ((a == 'I') && (b == 'B')) return 1.9;
+  if ((a == 'I') && (b == 'C')) return 4.1;
+  if ((a == 'I') && (b == 'D')) return 1.4;
+  if ((a == 'I') && (b == 'E')) return 2.5;
+  if ((a == 'I') && (b == 'F')) return 6.2;
+  if ((a == 'I') && (b == 'G')) return 0.7;
+  if ((a == 'I') && (b == 'H')) return 3;
+  if ((a == 'I') && (b == 'I')) return 9.2;
 
-	   iMaxDist = i;
+  if ((a == 'K') && (b == 'A')) return 4.8;
+  if ((a == 'K') && (b == 'B')) return 5.85;
+  if ((a == 'K') && (b == 'C')) return 2.4;
+  if ((a == 'K') && (b == 'D')) return 5.7;
+  if ((a == 'K') && (b == 'E')) return 6.4;
+  if ((a == 'K') && (b == 'F')) return 1.9;
+  if ((a == 'K') && (b == 'G')) return 4.1;
+  if ((a == 'K') && (b == 'H')) return 5.8;
+  if ((a == 'K') && (b == 'I')) return 3.1;
+  if ((a == 'K') && (b == 'K')) return 8.4;
 
-       MaxDist = dist;
+  if ((a == 'L') && (b == 'A')) return 4;
+  if ((a == 'L') && (b == 'B')) return 1.7;
+  if ((a == 'L') && (b == 'C')) return 3.7;
+  if ((a == 'L') && (b == 'D')) return 1.2;
+  if ((a == 'L') && (b == 'E')) return 2.4;
+  if ((a == 'L') && (b == 'F')) return 7.2;
+  if ((a == 'L') && (b == 'G')) return 0.8;
+  if ((a == 'L') && (b == 'H')) return 3.3;
+  if ((a == 'L') && (b == 'I')) return 8;
+  if ((a == 'L') && (b == 'K')) return 3.1;
+  if ((a == 'L') && (b == 'L')) return 9.2;
 
-	 } 
+  if ((a == 'M') && (b == 'A')) return 4.5;
+  if ((a == 'M') && (b == 'B')) return 2.6;
+  if ((a == 'M') && (b == 'C')) return 4.3;
+  if ((a == 'M') && (b == 'D')) return 2.2;
+  if ((a == 'M') && (b == 'E')) return 3.2;
+  if ((a == 'M') && (b == 'F')) return 6.8;
+  if ((a == 'M') && (b == 'G')) return 1.7;
+  if ((a == 'M') && (b == 'H')) return 3.9;
+  if ((a == 'M') && (b == 'I')) return 7.7;
+  if ((a == 'M') && (b == 'K')) return 3.8;
+  if ((a == 'M') && (b == 'L')) return 8.8;
+  if ((a == 'M') && (b == 'M')) return 9.5;
 
-   }
+  if ((a == 'N') && (b == 'A')) return 4.9;
+  if ((a == 'N') && (b == 'B')) return 8.2;
+  if ((a == 'N') && (b == 'C')) return 3.4;
+  if ((a == 'N') && (b == 'D')) return 7.4;
+  if ((a == 'N') && (b == 'E')) return 6.1;
+  if ((a == 'N') && (b == 'F')) return 2.1;
+  if ((a == 'N') && (b == 'G')) return 5.6;
+  if ((a == 'N') && (b == 'H')) return 6.4;
+  if ((a == 'N') && (b == 'I')) return 2.4;
+  if ((a == 'N') && (b == 'K')) return 6;
+  if ((a == 'N') && (b == 'L')) return 2.2;
+  if ((a == 'N') && (b == 'M')) return 3;
+  if ((a == 'N') && (b == 'N')) return 9;
 
-   return iMaxDist;
+  if ((a == 'P') && (b == 'A')) return 5.5;
+  if ((a == 'P') && (b == 'B')) return 4.4;
+  if ((a == 'P') && (b == 'C')) return 2.1;
+  if ((a == 'P') && (b == 'D')) return 4.5;
+  if ((a == 'P') && (b == 'E')) return 4.7;
+  if ((a == 'P') && (b == 'F')) return 1.4;
+  if ((a == 'P') && (b == 'G')) return 3.6;
+  if ((a == 'P') && (b == 'H')) return 4.1;
+  if ((a == 'P') && (b == 'I')) return 2.6;
+  if ((a == 'P') && (b == 'K')) return 4.6;
+  if ((a == 'P') && (b == 'L')) return 2.9;
+  if ((a == 'P') && (b == 'M')) return 2.8;
+  if ((a == 'P') && (b == 'N')) return 4.3;
+  if ((a == 'P') && (b == 'P')) return 12.8;
 
-}
+  if ((a == 'Q') && (b == 'A')) return 5;
+  if ((a == 'Q') && (b == 'B')) return 6;
+  if ((a == 'Q') && (b == 'C')) return 2.8;
+  if ((a == 'Q') && (b == 'D')) return 6.1;
+  if ((a == 'Q') && (b == 'E')) return 6.9;
+  if ((a == 'Q') && (b == 'F')) return 2.6;
+  if ((a == 'Q') && (b == 'G')) return 4.2;
+  if ((a == 'Q') && (b == 'H')) return 6.4;
+  if ((a == 'Q') && (b == 'I')) return 3.3;
+  if ((a == 'Q') && (b == 'K')) return 6.7;
+  if ((a == 'Q') && (b == 'L')) return 3.6;
+  if ((a == 'Q') && (b == 'M')) return 4.2;
+  if ((a == 'Q') && (b == 'N')) return 5.9;
+  if ((a == 'Q') && (b == 'P')) return 5;
+  if ((a == 'Q') && (b == 'Q')) return 7.9;
 
-
+  if ((a == 'R') && (b == 'A')) return 4.6;
+  if ((a == 'R') && (b == 'B')) return 5.2;
+  if ((a == 'R') && (b == 'C')) return 3;
+  if ((a == 'R') && (b == 'D')) return 4.9;
+  if ((a == 'R') && (b == 'E')) return 5.6;
+  if ((a == 'R') && (b == 'F')) return 2;
+  if ((a == 'R') && (b == 'G')) return 4.2;
+  if ((a == 'R') && (b == 'H')) return 5.8;
+  if ((a == 'R') && (b == 'I')) return 2.8;
+  if ((a == 'R') && (b == 'K')) return 7.9;
+  if ((a == 'R') && (b == 'L')) return 3;
+  if ((a == 'R') && (b == 'M')) return 3.5;
+  if ((a == 'R') && (b == 'N')) return 5.5;
+  if ((a == 'R') && (b == 'P')) return 4.3;
+  if ((a == 'R') && (b == 'Q')) return 6.7;
+  if ((a == 'R') && (b == 'R')) return 9.9;
 
-int FindMaxXYDistIdxLast(double **x_str, int Npts) {
+  if ((a == 'S') && (b == 'A')) return 6.3;
+  if ((a == 'S') && (b == 'B')) return 5.9;
+  if ((a == 'S') && (b == 'C')) return 5.3;
+  if ((a == 'S') && (b == 'D')) return 5.7;
+  if ((a == 'S') && (b == 'E')) return 5.4;
+  if ((a == 'S') && (b == 'F')) return 2.4;
+  if ((a == 'S') && (b == 'G')) return 5.6;
+  if ((a == 'S') && (b == 'H')) return 5;
+  if ((a == 'S') && (b == 'I')) return 3.4;
+  if ((a == 'S') && (b == 'K')) return 5.3;
+  if ((a == 'S') && (b == 'L')) return 3.1;
+  if ((a == 'S') && (b == 'M')) return 3.8;
+  if ((a == 'S') && (b == 'N')) return 6.1;
+  if ((a == 'S') && (b == 'P')) return 5.6;
+  if ((a == 'S') && (b == 'Q')) return 5.4;
+  if ((a == 'S') && (b == 'R')) return 5;
+  if ((a == 'S') && (b == 'S')) return 7.4;
 
-   int i, iMaxDist;
+  if ((a == 'T') && (b == 'A')) return 5.8;
+  if ((a == 'T') && (b == 'B')) return 5.45;
+  if ((a == 'T') && (b == 'C')) return 4.7;
+  if ((a == 'T') && (b == 'D')) return 5.2;
+  if ((a == 'T') && (b == 'E')) return 5.1;
+  if ((a == 'T') && (b == 'F')) return 3;
+  if ((a == 'T') && (b == 'G')) return 4.1;
+  if ((a == 'T') && (b == 'H')) return 4.9;
+  if ((a == 'T') && (b == 'I')) return 4.6;
+  if ((a == 'T') && (b == 'K')) return 5.3;
+  if ((a == 'T') && (b == 'L')) return 3.9;
+  if ((a == 'T') && (b == 'M')) return 4.6;
+  if ((a == 'T') && (b == 'N')) return 5.7;
+  if ((a == 'T') && (b == 'P')) return 5.3;
+  if ((a == 'T') && (b == 'Q')) return 5.2;
+  if ((a == 'T') && (b == 'R')) return 5;
+  if ((a == 'T') && (b == 'S')) return 6.7;
+  if ((a == 'T') && (b == 'T')) return 7.7;
 
-   double MaxDist, dist;
+  if ((a == 'V') && (b == 'A')) return 5.3;
+  if ((a == 'V') && (b == 'B')) return 2.65;
+  if ((a == 'V') && (b == 'C')) return 5.2;
+  if ((a == 'V') && (b == 'D')) return 2.3;
+  if ((a == 'V') && (b == 'E')) return 3.3;
+  if ((a == 'V') && (b == 'F')) return 5.3;
+  if ((a == 'V') && (b == 'G')) return 1.9;
+  if ((a == 'V') && (b == 'H')) return 3.2;
+  if ((a == 'V') && (b == 'I')) return 8.3;
+  if ((a == 'V') && (b == 'K')) return 3.5;
+  if ((a == 'V') && (b == 'L')) return 7;
+  if ((a == 'V') && (b == 'M')) return 6.8;
+  if ((a == 'V') && (b == 'N')) return 3;
+  if ((a == 'V') && (b == 'P')) return 3.4;
+  if ((a == 'V') && (b == 'Q')) return 3.7;
+  if ((a == 'V') && (b == 'R')) return 3.2;
+  if ((a == 'V') && (b == 'S')) return 4.2;
+  if ((a == 'V') && (b == 'T')) return 5.2;
+  if ((a == 'V') && (b == 'V')) return 8.6;
 
-   MaxDist  = sqrt( SQR(x_str[1][0]) + SQR(x_str[2][0]) );
+  if ((a == 'W') && (b == 'A')) return 1.6;
+  if ((a == 'W') && (b == 'B')) return 0.8;
+  if ((a == 'W') && (b == 'C')) return 4.2;
+  if ((a == 'W') && (b == 'D')) return 0;
+  if ((a == 'W') && (b == 'E')) return 0.9;
+  if ((a == 'W') && (b == 'F')) return 8.8;
+  if ((a == 'W') && (b == 'G')) return 1.2;
+  if ((a == 'W') && (b == 'H')) return 4.4;
+  if ((a == 'W') && (b == 'I')) return 3.4;
+  if ((a == 'W') && (b == 'K')) return 1.7;
+  if ((a == 'W') && (b == 'L')) return 4.5;
+  if ((a == 'W') && (b == 'M')) return 4.2;
+  if ((a == 'W') && (b == 'N')) return 1.6;
+  if ((a == 'W') && (b == 'P')) return 0.2;
+  if ((a == 'W') && (b == 'Q')) return 2.5;
+  if ((a == 'W') && (b == 'R')) return 3.6;
+  if ((a == 'W') && (b == 'S')) return 1.9;
+  if ((a == 'W') && (b == 'T')) return 1.7;
+  if ((a == 'W') && (b == 'V')) return 2.6;
+  if ((a == 'W') && (b == 'W')) return 19.4;
 
-   iMaxDist = 0;
+  if ((a == 'Y') && (b == 'A')) return 3;
+  if ((a == 'Y') && (b == 'B')) return 3.1;
+  if ((a == 'Y') && (b == 'C')) return 4.7;
+  if ((a == 'Y') && (b == 'D')) return 2.4;
+  if ((a == 'Y') && (b == 'E')) return 2.5;
+  if ((a == 'Y') && (b == 'F')) return 10.3;
+  if ((a == 'Y') && (b == 'G')) return 1.2;
+  if ((a == 'Y') && (b == 'H')) return 7.4;
+  if ((a == 'Y') && (b == 'I')) return 4.5;
+  if ((a == 'Y') && (b == 'K')) return 3.1;
+  if ((a == 'Y') && (b == 'L')) return 5.2;
+  if ((a == 'Y') && (b == 'M')) return 5;
+  if ((a == 'Y') && (b == 'N')) return 3.8;
+  if ((a == 'Y') && (b == 'P')) return 2.1;
+  if ((a == 'Y') && (b == 'Q')) return 3.5;
+  if ((a == 'Y') && (b == 'R')) return 3.4;
+  if ((a == 'Y') && (b == 'S')) return 3.3;
+  if ((a == 'Y') && (b == 'T')) return 3.3;
+  if ((a == 'Y') && (b == 'V')) return 4.1;
+  if ((a == 'Y') && (b == 'W')) return 9.3;
+  if ((a == 'Y') && (b == 'Y')) return 13;
 
-   for(i=1; i<Npts; i++) {
+  if ((a == 'Z') && (b == 'A')) return 5.1;
+  if ((a == 'Z') && (b == 'C')) return 2.5;
+  if ((a == 'Z') && (b == 'D')) return 7;
+  if ((a == 'Z') && (b == 'E')) return 7.85;
+  if ((a == 'Z') && (b == 'F')) return 1.95;
+  if ((a == 'Z') && (b == 'G')) return 4.3;
+  if ((a == 'Z') && (b == 'H')) return 6;
+  if ((a == 'Z') && (b == 'I')) return 2.9;
+  if ((a == 'Z') && (b == 'K')) return 6.55;
+  if ((a == 'Z') && (b == 'L')) return 3;
+  if ((a == 'Z') && (b == 'M')) return 3.7;
+  if ((a == 'Z') && (b == 'N')) return 6;
+  if ((a == 'Z') && (b == 'P')) return 4.85;
+  if ((a == 'Z') && (b == 'Q')) return 7.4;
+  if ((a == 'Z') && (b == 'R')) return 6.15;
+  if ((a == 'Z') && (b == 'S')) return 5.4;
+  if ((a == 'Z') && (b == 'T')) return 5.15;
+  if ((a == 'Z') && (b == 'V')) return 3.5;
+  if ((a == 'Z') && (b == 'W')) return 1.7;
+  if ((a == 'Z') && (b == 'Y')) return 3;
+  if ((a == 'Z') && (b == 'Z')) return 7.9;
 
-     dist  = sqrt( SQR(x_str[1][i]) + SQR(x_str[2][i]) );
+  if (a == b)
+    return 12;
+  else
+    return 0;
+} /* gonnet_p */
 
-	 if( dist > MaxDist) {
+double pam120_p(char a, char b, int altered, int use_carbonyl) {
+  if (use_carbonyl) {
+    if (isascii(a) != isascii(b))
+      return -1000;
+    else {
+      if (! isascii(a)) {
+	a = toascii(a);
+	b = toascii(b);
+	if (isalpha(a) != isalpha(b))
+	  return -1000;
+      }
+      if (isalpha(a) && isalpha(b)) {
+	if (isupper(a) != isupper(b))
+	  return -1000;
+	else if (islower(a)) {
+	  a = _toupper(a);
+	  b = _toupper(b);
+	}
+      }
+    }
+  }
 
-	   iMaxDist = i;
+  if (altered && (! (isalpha(a) && isalpha(b)))) {
+    if (a == b)
+      return 1000;
+    else
+      return -1000;
+  }
 
-       MaxDist = dist;
+  if (a < b) return pam120_p(b,a,0,0);
 
-	 } 
+  if ((a == 'A') && (b == 'A')) return 11.0;
 
-   }
+  if ((a == 'B') && (b == 'A')) return 8.0;
+  if ((a == 'B') && (b == 'B')) return 12.0;
 
-   return iMaxDist;
+  if ((a == 'C') && (b == 'A')) return 5.0;
+  if ((a == 'C') && (b == 'B')) return 2.0;
+  if ((a == 'C') && (b == 'C')) return 17.0;
 
-}
+  if ((a == 'D') && (b == 'A')) return 8.0;
+  if ((a == 'D') && (b == 'B')) return 12.0;
+  if ((a == 'D') && (b == 'C')) return 1.0;
+  if ((a == 'D') && (b == 'D')) return 13.0;
 
-
+  if ((a == 'E') && (b == 'A')) return 8.0;
+  if ((a == 'E') && (b == 'B')) return 11.0;
+  if ((a == 'E') && (b == 'C')) return 1.0;
+  if ((a == 'E') && (b == 'D')) return 11.0;
+  if ((a == 'E') && (b == 'E')) return 13.0;
 
-double AlignZ(double x, double y, double z, double *angle_b, double *angle_c){
+  if ((a == 'F') && (b == 'A')) return 4.0;
+  if ((a == 'F') && (b == 'B')) return 3.0;
+  if ((a == 'F') && (b == 'C')) return 2.0;
+  if ((a == 'F') && (b == 'D')) return 1.0;
+  if ((a == 'F') && (b == 'E')) return 1.0;
+  if ((a == 'F') && (b == 'F')) return 16.0;
 
-  *angle_b = atan( -x/z );
+  if ((a == 'G') && (b == 'A')) return 9.0;
+  if ((a == 'G') && (b == 'B')) return 8.0;
+  if ((a == 'G') && (b == 'C')) return 4.0;
+  if ((a == 'G') && (b == 'D')) return 8.0;
+  if ((a == 'G') && (b == 'E')) return 7.0;
+  if ((a == 'G') && (b == 'F')) return 3.0;
+  if ((a == 'G') && (b == 'G')) return 13.0;
 
-  *angle_c = atan( -y/(z*cos( *angle_b)-x*sin( *angle_b)) );
+  if ((a == 'H') && (b == 'A')) return 5.0;
+  if ((a == 'H') && (b == 'B')) return 9.0;
+  if ((a == 'H') && (b == 'C')) return 4.0;
+  if ((a == 'H') && (b == 'D')) return 8.0;
+  if ((a == 'H') && (b == 'E')) return 7.0;
+  if ((a == 'H') && (b == 'F')) return 5.0;
+  if ((a == 'H') && (b == 'G')) return 4.0;
+  if ((a == 'H') && (b == 'H')) return 15.0;
 
-  return cos( *angle_b);
+  if ((a == 'I') && (b == 'A')) return 7.0;
+  if ((a == 'I') && (b == 'B')) return 5.0;
+  if ((a == 'I') && (b == 'C')) return 5.0;
+  if ((a == 'I') && (b == 'D')) return 5.0;
+  if ((a == 'I') && (b == 'E')) return 5.0;
+  if ((a == 'I') && (b == 'F')) return 8.0;
+  if ((a == 'I') && (b == 'G')) return 4.0;
+  if ((a == 'I') && (b == 'H')) return 4.0;
+  if ((a == 'I') && (b == 'I')) return 14.0;
 
-}
+  if ((a == 'K') && (b == 'A')) return 6.0;
+  if ((a == 'K') && (b == 'B')) return 8.0;
+  if ((a == 'K') && (b == 'C')) return 1.0;
+  if ((a == 'K') && (b == 'D')) return 7.0;
+  if ((a == 'K') && (b == 'E')) return 7.0;
+  if ((a == 'K') && (b == 'F')) return 1.0;
+  if ((a == 'K') && (b == 'G')) return 5.0;
+  if ((a == 'K') && (b == 'H')) return 6.0;
+  if ((a == 'K') && (b == 'I')) return 5.0;
+  if ((a == 'K') && (b == 'K')) return 13.0;
 
-
+  if ((a == 'L') && (b == 'A')) return 5.0;
+  if ((a == 'L') && (b == 'B')) return 4.0;
+  if ((a == 'L') && (b == 'C')) return 1.0;
+  if ((a == 'L') && (b == 'D')) return 3.0;
+  if ((a == 'L') && (b == 'E')) return 4.0;
+  if ((a == 'L') && (b == 'F')) return 8.0;
+  if ((a == 'L') && (b == 'G')) return 3.0;
+  if ((a == 'L') && (b == 'H')) return 5.0;
+  if ((a == 'L') && (b == 'I')) return 9.0;
+  if ((a == 'L') && (b == 'K')) return 4.0;
+  if ((a == 'L') && (b == 'L')) return 13.0;
 
-double FormRotMatrZ(double **Rtemp, double angle_a){
+  if ((a == 'M') && (b == 'A')) return 6.0;
+  if ((a == 'M') && (b == 'B')) return 4.0;
+  if ((a == 'M') && (b == 'C')) return 2.0;
+  if ((a == 'M') && (b == 'D')) return 4.0;
+  if ((a == 'M') && (b == 'E')) return 5.0;
+  if ((a == 'M') && (b == 'F')) return 7.0;
+  if ((a == 'M') && (b == 'G')) return 4.0;
+  if ((a == 'M') && (b == 'H')) return 4.0;
+  if ((a == 'M') && (b == 'I')) return 9.0;
+  if ((a == 'M') && (b == 'K')) return 8.0;
+  if ((a == 'M') && (b == 'L')) return 11.0;
+  if ((a == 'M') && (b == 'M')) return 16.0;
 
-  Rtemp[1][1] = cos(angle_a);  Rtemp[1][2] = sin(angle_a); Rtemp[1][3] = 0.0e0; 
+  if ((a == 'N') && (b == 'A')) return 7.0;
+  if ((a == 'N') && (b == 'B')) return 11.0;
+  if ((a == 'N') && (b == 'C')) return 3.0;
+  if ((a == 'N') && (b == 'D')) return 10.0;
+  if ((a == 'N') && (b == 'E')) return 9.0;
+  if ((a == 'N') && (b == 'F')) return 4.0;
+  if ((a == 'N') && (b == 'G')) return 8.0;
+  if ((a == 'N') && (b == 'H')) return 10.0;
+  if ((a == 'N') && (b == 'I')) return 6.0;
+  if ((a == 'N') && (b == 'K')) return 9.0;
+  if ((a == 'N') && (b == 'L')) return 4.0;
+  if ((a == 'N') && (b == 'M')) return 5.0;
+  if ((a == 'N') && (b == 'N')) return 12.0;
 
-  Rtemp[2][1] = -sin(angle_a); Rtemp[2][2] = cos(angle_a); Rtemp[2][3] = 0.0e0; 
+  if ((a == 'P') && (b == 'A')) return 9.0;
+  if ((a == 'P') && (b == 'B')) return 6.0;
+  if ((a == 'P') && (b == 'C')) return 4.0;
+  if ((a == 'P') && (b == 'D')) return 5.0;
+  if ((a == 'P') && (b == 'E')) return 6.0;
+  if ((a == 'P') && (b == 'F')) return 3.0;
+  if ((a == 'P') && (b == 'G')) return 6.0;
+  if ((a == 'P') && (b == 'H')) return 7.0;
+  if ((a == 'P') && (b == 'I')) return 5.0;
+  if ((a == 'P') && (b == 'K')) return 6.0;
+  if ((a == 'P') && (b == 'L')) return 5.0;
+  if ((a == 'P') && (b == 'M')) return 5.0;
+  if ((a == 'P') && (b == 'N')) return 6.0;
+  if ((a == 'P') && (b == 'P')) return 14.0;
 
-  Rtemp[3][1] = 0.0e0;         Rtemp[3][2] = 0.0e0;        Rtemp[3][3] = 1.0e0; 
+  if ((a == 'Q') && (b == 'A')) return 7.0;
+  if ((a == 'Q') && (b == 'B')) return 8.0;
+  if ((a == 'Q') && (b == 'C')) return 1.0;
+  if ((a == 'Q') && (b == 'D')) return 9.0;
+  if ((a == 'Q') && (b == 'E')) return 10.0;
+  if ((a == 'Q') && (b == 'F')) return 2.0;
+  if ((a == 'Q') && (b == 'G')) return 5.0;
+  if ((a == 'Q') && (b == 'H')) return 11.0;
+  if ((a == 'Q') && (b == 'I')) return 5.0;
+  if ((a == 'Q') && (b == 'K')) return 8.0;
+  if ((a == 'Q') && (b == 'L')) return 6.0;
+  if ((a == 'Q') && (b == 'M')) return 7.0;
+  if ((a == 'Q') && (b == 'N')) return 8.0;
+  if ((a == 'Q') && (b == 'P')) return 8.0;
+  if ((a == 'Q') && (b == 'Q')) return 14.0;
 
-  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+  if ((a == 'R') && (b == 'A')) return 5.0;
+  if ((a == 'R') && (b == 'B')) return 6.0;
+  if ((a == 'R') && (b == 'C')) return 4.0;
+  if ((a == 'R') && (b == 'D')) return 5.0;
+  if ((a == 'R') && (b == 'E')) return 5.0;
+  if ((a == 'R') && (b == 'F')) return 3.0;
+  if ((a == 'R') && (b == 'G')) return 4.0;
+  if ((a == 'R') && (b == 'H')) return 9.0;
+  if ((a == 'R') && (b == 'I')) return 6.0;
+  if ((a == 'R') && (b == 'K')) return 10.0;
+  if ((a == 'R') && (b == 'L')) return 4.0;
+  if ((a == 'R') && (b == 'M')) return 7.0;
+  if ((a == 'R') && (b == 'N')) return 7.0;
+  if ((a == 'R') && (b == 'P')) return 7.0;
+  if ((a == 'R') && (b == 'Q')) return 9.0;
+  if ((a == 'R') && (b == 'R')) return 14.0;
 
-}
+  if ((a == 'S') && (b == 'A')) return 9.0;
+  if ((a == 'S') && (b == 'B')) return 8.0;
+  if ((a == 'S') && (b == 'C')) return 8.0;
+  if ((a == 'S') && (b == 'D')) return 8.0;
+  if ((a == 'S') && (b == 'E')) return 7.0;
+  if ((a == 'S') && (b == 'F')) return 5.0;
+  if ((a == 'S') && (b == 'G')) return 9.0;
+  if ((a == 'S') && (b == 'H')) return 6.0;
+  if ((a == 'S') && (b == 'I')) return 6.0;
+  if ((a == 'S') && (b == 'K')) return 7.0;
+  if ((a == 'S') && (b == 'L')) return 4.0;
+  if ((a == 'S') && (b == 'M')) return 6.0;
+  if ((a == 'S') && (b == 'N')) return 9.0;
+  if ((a == 'S') && (b == 'P')) return 9.0;
+  if ((a == 'S') && (b == 'Q')) return 6.0;
+  if ((a == 'S') && (b == 'R')) return 7.0;
+  if ((a == 'S') && (b == 'S')) return 11.0;
 
-
+  if ((a == 'T') && (b == 'A')) return 9.0;
+  if ((a == 'T') && (b == 'B')) return 8.0;
+  if ((a == 'T') && (b == 'C')) return 5.0;
+  if ((a == 'T') && (b == 'D')) return 7.0;
+  if ((a == 'T') && (b == 'E')) return 6.0;
+  if ((a == 'T') && (b == 'F')) return 4.0;
+  if ((a == 'T') && (b == 'G')) return 7.0;
+  if ((a == 'T') && (b == 'H')) return 5.0;
+  if ((a == 'T') && (b == 'I')) return 8.0;
+  if ((a == 'T') && (b == 'K')) return 7.0;
+  if ((a == 'T') && (b == 'L')) return 5.0;
+  if ((a == 'T') && (b == 'M')) return 7.0;
+  if ((a == 'T') && (b == 'N')) return 8.0;
+  if ((a == 'T') && (b == 'P')) return 7.0;
+  if ((a == 'T') && (b == 'Q')) return 6.0;
+  if ((a == 'T') && (b == 'R')) return 6.0;
+  if ((a == 'T') && (b == 'S')) return 10.0;
+  if ((a == 'T') && (b == 'T')) return 12.0;
 
-double FormRotMatrY(double **Rtemp, double angle_a){
+  if ((a == 'V') && (b == 'A')) return 8.0;
+  if ((a == 'V') && (b == 'B')) return 5.0;
+  if ((a == 'V') && (b == 'C')) return 5.0;
+  if ((a == 'V') && (b == 'D')) return 5.0;
+  if ((a == 'V') && (b == 'E')) return 5.0;
+  if ((a == 'V') && (b == 'F')) return 5.0;
+  if ((a == 'V') && (b == 'G')) return 6.0;
+  if ((a == 'V') && (b == 'H')) return 5.0;
+  if ((a == 'V') && (b == 'I')) return 11.0;
+  if ((a == 'V') && (b == 'K')) return 4.0;
+  if ((a == 'V') && (b == 'L')) return 9.0;
+  if ((a == 'V') && (b == 'M')) return 9.0;
+  if ((a == 'V') && (b == 'N')) return 5.0;
+  if ((a == 'V') && (b == 'P')) return 6.0;
+  if ((a == 'V') && (b == 'Q')) return 5.0;
+  if ((a == 'V') && (b == 'R')) return 5.0;
+  if ((a == 'V') && (b == 'S')) return 6.0;
+  if ((a == 'V') && (b == 'T')) return 8.0;
+  if ((a == 'V') && (b == 'V')) return 13.0;
 
-  Rtemp[1][1] = cos(angle_a);  Rtemp[1][2] = 0.0e0; Rtemp[1][3] = sin(angle_a); 
+  if ((a == 'W') && (b == 'A')) return 1.0;
+  if ((a == 'W') && (b == 'B')) return 2.0;
+  if ((a == 'W') && (b == 'C')) return 0.0;
+  if ((a == 'W') && (b == 'D')) return 0.0;
+  if ((a == 'W') && (b == 'E')) return 0.0;
+  if ((a == 'W') && (b == 'F')) return 7.0;
+  if ((a == 'W') && (b == 'G')) return 0.0;
+  if ((a == 'W') && (b == 'H')) return 5.0;
+  if ((a == 'W') && (b == 'I')) return 2.0;
+  if ((a == 'W') && (b == 'K')) return 3.0;
+  if ((a == 'W') && (b == 'L')) return 5.0;
+  if ((a == 'W') && (b == 'M')) return 2.0;
+  if ((a == 'W') && (b == 'N')) return 4.0;
+  if ((a == 'W') && (b == 'P')) return 1.0;
+  if ((a == 'W') && (b == 'Q')) return 2.0;
+  if ((a == 'W') && (b == 'R')) return 9.0;
+  if ((a == 'W') && (b == 'S')) return 6.0;
+  if ((a == 'W') && (b == 'T')) return 2.0;
+  if ((a == 'W') && (b == 'V')) return 0.0;
+  if ((a == 'W') && (b == 'W')) return 20.0;
 
-  Rtemp[2][1] = 0.0e0;         Rtemp[2][2] = 1.0e0; Rtemp[2][3] = 0.0e0; 
+/*   if ((a == 'X') && (b == 'A')) return 2; */
+/*   if ((a == 'X') && (b == 'B')) return 4; */
+/*   if ((a == 'X') && (b == 'C')) return 0; */
+/*   if ((a == 'X') && (b == 'D')) return 0; */
+/*   if ((a == 'X') && (b == 'E')) return 0; */
+/*   if ((a == 'X') && (b == 'F')) return 2; */
+/*   if ((a == 'X') && (b == 'G')) return 0; */
+/*   if ((a == 'X') && (b == 'H')) return 8; */
+/*   if ((a == 'X') && (b == 'I')) return 4; */
+/*   if ((a == 'X') && (b == 'K')) return 2; */
+/*   if ((a == 'X') && (b == 'L')) return 2; */
+/*   if ((a == 'X') && (b == 'M')) return 4; */
+/*   if ((a == 'X') && (b == 'N')) return 6; */
+/*   if ((a == 'X') && (b == 'P')) return 2; */
+/*   if ((a == 'X') && (b == 'Q')) return 2; */
+/*   if ((a == 'X') && (b == 'R')) return 6; */
+/*   if ((a == 'X') && (b == 'S')) return 8; */
+/*   if ((a == 'X') && (b == 'T')) return 4; */
+/*   if ((a == 'X') && (b == 'V')) return 0; */
+/*   if ((a == 'X') && (b == 'W')) return 0; */
+/*   if ((a == 'X') && (b == 'X')) return 12; */
 
-  Rtemp[3][1] = -sin(angle_a); Rtemp[3][2] = 0.0e0; Rtemp[3][3] = cos(angle_a); 
+  if ((a == 'Y') && (b == 'A')) return 4.0;
+  if ((a == 'Y') && (b == 'B')) return 5.0;
+  if ((a == 'Y') && (b == 'C')) return 7.0;
+  if ((a == 'Y') && (b == 'D')) return 3.0;
+  if ((a == 'Y') && (b == 'E')) return 3.0;
+  if ((a == 'Y') && (b == 'F')) return 12.0;
+  if ((a == 'Y') && (b == 'G')) return 2.0;
+  if ((a == 'Y') && (b == 'H')) return 7.0;
+  if ((a == 'Y') && (b == 'I')) return 6.0;
+  if ((a == 'Y') && (b == 'K')) return 3.0;
+  if ((a == 'Y') && (b == 'L')) return 6.0;
+  if ((a == 'Y') && (b == 'M')) return 4.0;
+  if ((a == 'Y') && (b == 'N')) return 6.0;
+  if ((a == 'Y') && (b == 'P')) return 2.0;
+  if ((a == 'Y') && (b == 'Q')) return 3.0;
+  if ((a == 'Y') && (b == 'R')) return 3.0;
+  if ((a == 'Y') && (b == 'S')) return 5.0;
+  if ((a == 'Y') && (b == 'T')) return 5.0;
+  if ((a == 'Y') && (b == 'V')) return 5.0;
+  if ((a == 'Y') && (b == 'W')) return 6.0;
+/*   if ((a == 'Y') && (b == 'X')) return 4; */
+  if ((a == 'Y') && (b == 'Y')) return 16.0;
 
-  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+  if ((a == 'Z') && (b == 'A')) return 7.0;
+  if ((a == 'Z') && (b == 'B')) return 10.0;
+  if ((a == 'Z') && (b == 'C')) return 1.0;
+  if ((a == 'Z') && (b == 'D')) return 11.0;
+  if ((a == 'Z') && (b == 'E')) return 12.0;
+  if ((a == 'Z') && (b == 'F')) return 2.0;
+  if ((a == 'Z') && (b == 'G')) return 6.0;
+  if ((a == 'Z') && (b == 'H')) return 9.0;
+  if ((a == 'Z') && (b == 'I')) return 5.0;
+  if ((a == 'Z') && (b == 'K')) return 7.0;
+  if ((a == 'Z') && (b == 'L')) return 5.0;
+  if ((a == 'Z') && (b == 'M')) return 6.0;
+  if ((a == 'Z') && (b == 'N')) return 8.0;
+  if ((a == 'Z') && (b == 'P')) return 7.0;
+  if ((a == 'Z') && (b == 'Q')) return 12.0;
+  if ((a == 'Z') && (b == 'R')) return 7.0;
+  if ((a == 'Z') && (b == 'S')) return 7.0;
+  if ((a == 'Z') && (b == 'T')) return 6.0;
+  if ((a == 'Z') && (b == 'V')) return 5.0;
+  if ((a == 'Z') && (b == 'W')) return 1.0;
+/*   if ((a == 'Z') && (b == 'X')) return 2; */
+  if ((a == 'Z') && (b == 'Y')) return 3.0;
+  if ((a == 'Z') && (b == 'Z')) return 12.0;
 
-}
+  if (a == b)
+    return 6.0;
+  else
+    return 0.0;
+} /* pam120_p */
 
-
+/* citeseer.ist.psu.edu/naor96amino.html - Amino Acid Pair Interchanges at
+ * Spatially Conserved Locations - Nussinov
+ */
 
-double FormRotMatrX(double **Rtemp, double angle_a){
+double nussinov(char a, char b, int altered, int use_carbonyl) {
 
-  Rtemp[1][1] = 1.0e0; Rtemp[1][2] = 0.0e0;         Rtemp[1][3] = 0.0e0; 
+  if (use_carbonyl) {
+    if (isascii(a) != isascii(b))
+      return -1000;
+    else {
+      if (! isascii(a)) {
+	a = toascii(a);
+	b = toascii(b);
+	if (isalpha(a) != isalpha(b))
+	  return -1000;
+      }
+      if (isalpha(a) && isalpha(b)) {
+	if (isupper(a) != isupper(b))
+	  return -1000;
+	else if (islower(a)) {
+	  a = _toupper(a);
+	  b = _toupper(b);
+	}
+      }
+    }
+  }
 
-  Rtemp[2][1] = 0.0e0; Rtemp[2][2] = cos(angle_a);  Rtemp[2][3] = sin(angle_a); 
+  if (altered && (! (isalpha(a) && isalpha(b)))) {
+    if (a == b)
+      return 1000;
+    else
+      return -1000;
+  }
 
-  Rtemp[3][1] = 0.0e0; Rtemp[3][2] = -sin(angle_a); Rtemp[3][3] = cos(angle_a); 
+  if (a < b) return nussinov(b,a,0,0);
 
-  return Rtemp[1][1]+Rtemp[2][2]+Rtemp[3][3];
+  if ((a == 'A') && (b == 'A')) return 13;
 
-}
+  if ((a == 'B') && (b == 'A')) return 9;
+  if ((a == 'B') && (b == 'B')) return 18.5;
 
-
+  if ((a == 'C') && (b == 'A')) return 11;
+  if ((a == 'C') && (b == 'B')) return 4.5;
+  if ((a == 'C') && (b == 'C')) return 23;
 
-double MAX2(double a, double b){
+  if ((a == 'D') && (b == 'A')) return 9;
+  if ((a == 'D') && (b == 'B')) return 18.5;
+  if ((a == 'D') && (b == 'C')) return 5;
+  if ((a == 'D') && (b == 'D')) return 20;
 
-  if( a>b ) return a;
+  if ((a == 'E') && (b == 'A')) return 9;
+  if ((a == 'E') && (b == 'B')) return 15.5;
+  if ((a == 'E') && (b == 'C')) return 3;
+  if ((a == 'E') && (b == 'D')) return 16;
+  if ((a == 'E') && (b == 'E')) return 20;
 
-  return b;
+  if ((a == 'F') && (b == 'A')) return 8;
+  if ((a == 'F') && (b == 'B')) return 3;
+  if ((a == 'F') && (b == 'C')) return 12;
+  if ((a == 'F') && (b == 'D')) return 3;
+  if ((a == 'F') && (b == 'E')) return 3;
+  if ((a == 'F') && (b == 'F')) return 15;
 
-}
+  if ((a == 'G') && (b == 'A')) return 9;
+  if ((a == 'G') && (b == 'B')) return 13.5;
+  if ((a == 'G') && (b == 'C')) return 9;
+  if ((a == 'G') && (b == 'D')) return 13;
+  if ((a == 'G') && (b == 'E')) return 9;
+  if ((a == 'G') && (b == 'F')) return 6;
+  if ((a == 'G') && (b == 'G')) return 21;
 
-
+  if ((a == 'H') && (b == 'A')) return 8;
+  if ((a == 'H') && (b == 'B')) return 11.5;
+  if ((a == 'H') && (b == 'C')) return 7;
+  if ((a == 'H') && (b == 'D')) return 12;
+  if ((a == 'H') && (b == 'E')) return 11;
+  if ((a == 'H') && (b == 'F')) return 7;
+  if ((a == 'H') && (b == 'G')) return 12;
+  if ((a == 'H') && (b == 'H')) return 14;
 
-double MIN2(double a, double b){
+  if ((a == 'I') && (b == 'A')) return 7;
+  if ((a == 'I') && (b == 'B')) return 0;
+  if ((a == 'I') && (b == 'C')) return 13;
+  if ((a == 'I') && (b == 'D')) return 0;
+  if ((a == 'I') && (b == 'E')) return 0;
+  if ((a == 'I') && (b == 'F')) return 15;
+  if ((a == 'I') && (b == 'G')) return 2;
+  if ((a == 'I') && (b == 'H')) return 6;
+  if ((a == 'I') && (b == 'I')) return 19;
 
-  if( a<b ) return a;
+  if ((a == 'K') && (b == 'A')) return 9;
+  if ((a == 'K') && (b == 'B')) return 15.5;
+  if ((a == 'K') && (b == 'C')) return 2;
+  if ((a == 'K') && (b == 'D')) return 16;
+  if ((a == 'K') && (b == 'E')) return 18;
+  if ((a == 'K') && (b == 'F')) return 2;
+  if ((a == 'K') && (b == 'G')) return 9;
+  if ((a == 'K') && (b == 'H')) return 10;
+  if ((a == 'K') && (b == 'I')) return 0;
+  if ((a == 'K') && (b == 'K')) return 22;
 
-  return b;
+  if ((a == 'L') && (b == 'A')) return 9;
+  if ((a == 'L') && (b == 'B')) return 1.5;
+  if ((a == 'L') && (b == 'C')) return 11;
+  if ((a == 'L') && (b == 'D')) return 1;
+  if ((a == 'L') && (b == 'E')) return 3;
+  if ((a == 'L') && (b == 'F')) return 15;
+  if ((a == 'L') && (b == 'G')) return 3;
+  if ((a == 'L') && (b == 'H')) return 6;
+  if ((a == 'L') && (b == 'I')) return 16;
+  if ((a == 'L') && (b == 'K')) return 2;
+  if ((a == 'L') && (b == 'L')) return 18;
 
-}
+  if ((a == 'M') && (b == 'A')) return 9;
+  if ((a == 'M') && (b == 'B')) return 5.5;
+  if ((a == 'M') && (b == 'C')) return 11;
+  if ((a == 'M') && (b == 'D')) return 5;
+  if ((a == 'M') && (b == 'E')) return 7;
+  if ((a == 'M') && (b == 'F')) return 12;
+  if ((a == 'M') && (b == 'G')) return 6;
+  if ((a == 'M') && (b == 'H')) return 8;
+  if ((a == 'M') && (b == 'I')) return 12;
+  if ((a == 'M') && (b == 'K')) return 5;
+  if ((a == 'M') && (b == 'L')) return 14;
+  if ((a == 'M') && (b == 'M')) return 13;
 
-
+  if ((a == 'N') && (b == 'A')) return 9;
+  if ((a == 'N') && (b == 'B')) return 17;
+  if ((a == 'N') && (b == 'C')) return 4;
+  if ((a == 'N') && (b == 'D')) return 17;
+  if ((a == 'N') && (b == 'E')) return 15;
+  if ((a == 'N') && (b == 'F')) return 3;
+  if ((a == 'N') && (b == 'G')) return 14;
+  if ((a == 'N') && (b == 'H')) return 11;
+  if ((a == 'N') && (b == 'I')) return 0;
+  if ((a == 'N') && (b == 'K')) return 15;
+  if ((a == 'N') && (b == 'L')) return 2;
+  if ((a == 'N') && (b == 'M')) return 6;
+  if ((a == 'N') && (b == 'N')) return 17;
 
-/*=====================================================================*/
+  if ((a == 'P') && (b == 'A')) return 9;
+  if ((a == 'P') && (b == 'B')) return 15;
+  if ((a == 'P') && (b == 'C')) return 8;
+  if ((a == 'P') && (b == 'D')) return 15;
+  if ((a == 'P') && (b == 'E')) return 9;
+  if ((a == 'P') && (b == 'F')) return 5;
+  if ((a == 'P') && (b == 'G')) return 15;
+  if ((a == 'P') && (b == 'H')) return 11;
+  if ((a == 'P') && (b == 'I')) return 1;
+  if ((a == 'P') && (b == 'K')) return 12;
+  if ((a == 'P') && (b == 'L')) return 1;
+  if ((a == 'P') && (b == 'M')) return 3;
+  if ((a == 'P') && (b == 'N')) return 15;
+  if ((a == 'P') && (b == 'P')) return 28;
 
-/* Returns sum(i=0..n-1, v[3*i]) */
+  if ((a == 'Q') && (b == 'A')) return 9;
+  if ((a == 'Q') && (b == 'B')) return 14.5;
+  if ((a == 'Q') && (b == 'C')) return 5;
+  if ((a == 'Q') && (b == 'D')) return 15;
+  if ((a == 'Q') && (b == 'E')) return 17;
+  if ((a == 'Q') && (b == 'F')) return 4;
+  if ((a == 'Q') && (b == 'G')) return 9;
+  if ((a == 'Q') && (b == 'H')) return 10;
+  if ((a == 'Q') && (b == 'I')) return 2;
+  if ((a == 'Q') && (b == 'K')) return 16;
+  if ((a == 'Q') && (b == 'L')) return 4;
+  if ((a == 'Q') && (b == 'M')) return 7;
+  if ((a == 'Q') && (b == 'N')) return 14;
+  if ((a == 'Q') && (b == 'P')) return 10;
+  if ((a == 'Q') && (b == 'Q')) return 16;
 
-
+  if ((a == 'R') && (b == 'A')) return 9;
+  if ((a == 'R') && (b == 'B')) return 13;
+  if ((a == 'R') && (b == 'C')) return 4;
+  if ((a == 'R') && (b == 'D')) return 13;
+  if ((a == 'R') && (b == 'E')) return 17;
+  if ((a == 'R') && (b == 'F')) return 4;
+  if ((a == 'R') && (b == 'G')) return 9;
+  if ((a == 'R') && (b == 'H')) return 12;
+  if ((a == 'R') && (b == 'I')) return 2;
+  if ((a == 'R') && (b == 'K')) return 18;
+  if ((a == 'R') && (b == 'L')) return 4;
+  if ((a == 'R') && (b == 'M')) return 7;
+  if ((a == 'R') && (b == 'N')) return 13;
+  if ((a == 'R') && (b == 'P')) return 10;
+  if ((a == 'R') && (b == 'Q')) return 14;
+  if ((a == 'R') && (b == 'R')) return 16;
 
-double vsumby3(double v[],  int n)
+  if ((a == 'S') && (b == 'A')) return 9;
+  if ((a == 'S') && (b == 'B')) return 13;
+  if ((a == 'S') && (b == 'C')) return 6;
+  if ((a == 'S') && (b == 'D')) return 13;
+  if ((a == 'S') && (b == 'E')) return 12;
+  if ((a == 'S') && (b == 'F')) return 5;
+  if ((a == 'S') && (b == 'G')) return 13;
+  if ((a == 'S') && (b == 'H')) return 11;
+  if ((a == 'S') && (b == 'I')) return 4;
+  if ((a == 'S') && (b == 'K')) return 12;
+  if ((a == 'S') && (b == 'L')) return 4;
+  if ((a == 'S') && (b == 'M')) return 6;
+  if ((a == 'S') && (b == 'N')) return 13;
+  if ((a == 'S') && (b == 'P')) return 12;
+  if ((a == 'S') && (b == 'Q')) return 11;
+  if ((a == 'S') && (b == 'R')) return 11;
+  if ((a == 'S') && (b == 'S')) return 14;
 
-  {
+  if ((a == 'T') && (b == 'A')) return 9;
+  if ((a == 'T') && (b == 'B')) return 11;
+  if ((a == 'T') && (b == 'C')) return 7;
+  if ((a == 'T') && (b == 'D')) return 11;
+  if ((a == 'T') && (b == 'E')) return 12;
+  if ((a == 'T') && (b == 'F')) return 7;
+  if ((a == 'T') && (b == 'G')) return 9;
+  if ((a == 'T') && (b == 'H')) return 9;
+  if ((a == 'T') && (b == 'I')) return 6;
+  if ((a == 'T') && (b == 'K')) return 11;
+  if ((a == 'T') && (b == 'L')) return 6;
+  if ((a == 'T') && (b == 'M')) return 7;
+  if ((a == 'T') && (b == 'N')) return 11;
+  if ((a == 'T') && (b == 'P')) return 10;
+  if ((a == 'T') && (b == 'Q')) return 10;
+  if ((a == 'T') && (b == 'R')) return 10;
+  if ((a == 'T') && (b == 'S')) return 11;
+  if ((a == 'T') && (b == 'T')) return 12;
 
-  double sum, temp;
+  if ((a == 'V') && (b == 'A')) return 7;
+  if ((a == 'V') && (b == 'B')) return 0.5;
+  if ((a == 'V') && (b == 'C')) return 13;
+  if ((a == 'V') && (b == 'D')) return 0;
+  if ((a == 'V') && (b == 'E')) return 0;
+  if ((a == 'V') && (b == 'F')) return 14;
+  if ((a == 'V') && (b == 'G')) return 4;
+  if ((a == 'V') && (b == 'H')) return 7;
+  if ((a == 'V') && (b == 'I')) return 18;
+  if ((a == 'V') && (b == 'K')) return 1;
+  if ((a == 'V') && (b == 'L')) return 14;
+  if ((a == 'V') && (b == 'M')) return 11;
+  if ((a == 'V') && (b == 'N')) return 1;
+  if ((a == 'V') && (b == 'P')) return 4;
+  if ((a == 'V') && (b == 'Q')) return 1;
+  if ((a == 'V') && (b == 'R')) return 3;
+  if ((a == 'V') && (b == 'S')) return 5;
+  if ((a == 'V') && (b == 'T')) return 8;
+  if ((a == 'V') && (b == 'V')) return 18;
 
-  int i; 
+  if ((a == 'W') && (b == 'A')) return 9;
+  if ((a == 'W') && (b == 'B')) return 5;
+  if ((a == 'W') && (b == 'C')) return 9;
+  if ((a == 'W') && (b == 'D')) return 5;
+  if ((a == 'W') && (b == 'E')) return 6;
+  if ((a == 'W') && (b == 'F')) return 12;
+  if ((a == 'W') && (b == 'G')) return 8;
+  if ((a == 'W') && (b == 'H')) return 8;
+  if ((a == 'W') && (b == 'I')) return 13;
+  if ((a == 'W') && (b == 'K')) return 4;
+  if ((a == 'W') && (b == 'L')) return 11;
+  if ((a == 'W') && (b == 'M')) return 10;
+  if ((a == 'W') && (b == 'N')) return 5;
+  if ((a == 'W') && (b == 'P')) return 4;
+  if ((a == 'W') && (b == 'Q')) return 7;
+  if ((a == 'W') && (b == 'R')) return 6;
+  if ((a == 'W') && (b == 'S')) return 7;
+  if ((a == 'W') && (b == 'T')) return 9;
+  if ((a == 'W') && (b == 'V')) return 13;
+  if ((a == 'W') && (b == 'W')) return 18;
 
-
+  if ((a == 'Y') && (b == 'A')) return 9;
+  if ((a == 'Y') && (b == 'B')) return 6.5;
+  if ((a == 'Y') && (b == 'C')) return 9;
+  if ((a == 'Y') && (b == 'D')) return 6;
+  if ((a == 'Y') && (b == 'E')) return 7;
+  if ((a == 'Y') && (b == 'F')) return 11;
+  if ((a == 'Y') && (b == 'G')) return 8;
+  if ((a == 'Y') && (b == 'H')) return 9;
+  if ((a == 'Y') && (b == 'I')) return 11;
+  if ((a == 'Y') && (b == 'K')) return 6;
+  if ((a == 'Y') && (b == 'L')) return 10;
+  if ((a == 'Y') && (b == 'M')) return 10;
+  if ((a == 'Y') && (b == 'N')) return 7;
+  if ((a == 'Y') && (b == 'P')) return 6;
+  if ((a == 'Y') && (b == 'Q')) return 8;
+  if ((a == 'Y') && (b == 'R')) return 7;
+  if ((a == 'Y') && (b == 'S')) return 8;
+  if ((a == 'Y') && (b == 'T')) return 9;
+  if ((a == 'Y') && (b == 'V')) return 11;
+  if ((a == 'Y') && (b == 'W')) return 11;
+  if ((a == 'Y') && (b == 'Y')) return 12;
 
-  sum = *v; n--; v += 3;
+  if ((a == 'Z') && (b == 'A')) return 9;
+  if ((a == 'Z') && (b == 'B')) return 15;
+  if ((a == 'Z') && (b == 'C')) return 4;
+  if ((a == 'Z') && (b == 'D')) return 15.5;
+  if ((a == 'Z') && (b == 'E')) return 18.5;
+  if ((a == 'Z') && (b == 'F')) return 3.5;
+  if ((a == 'Z') && (b == 'G')) return 9;
+  if ((a == 'Z') && (b == 'H')) return 10.5;
+  if ((a == 'Z') && (b == 'I')) return 1;
+  if ((a == 'Z') && (b == 'K')) return 17;
+  if ((a == 'Z') && (b == 'L')) return 3.5;
+  if ((a == 'Z') && (b == 'M')) return 7;
+  if ((a == 'Z') && (b == 'N')) return 14.5;
+  if ((a == 'Z') && (b == 'P')) return 9.5;
+  if ((a == 'Z') && (b == 'Q')) return 16.5;
+  if ((a == 'Z') && (b == 'R')) return 15.5;
+  if ((a == 'Z') && (b == 'S')) return 11.5;
+  if ((a == 'Z') && (b == 'T')) return 11;
+  if ((a == 'Z') && (b == 'V')) return 0.5;
+  if ((a == 'Z') && (b == 'W')) return 6.5;
+  if ((a == 'Z') && (b == 'Y')) return 7.5;
+  if ((a == 'Z') && (b == 'Z')) return 17;
 
-  for (i = 0; i != n; i++, v += 3) {
+  if (a == b)
+    return 12;
+  else
+    return 0;
+} /* nussinov */
 
-	  temp = *v;
+double blosum62(char a, char b, int altered, int use_carbonyl) {
 
-	  sum += *v;
+  if (use_carbonyl) {
+    if (isascii(a) != isascii(b))
+      return -1000;
+    else {
+      if (! isascii(a)) {
+	a = toascii(a);
+	b = toascii(b);
+	if (isalpha(a) != isalpha(b))
+	  return -1000;
+      }
+      if (isalpha(a) && isalpha(b)) {
+	if (isupper(a) != isupper(b))
+	  return -1000;
+	else if (islower(a)) {
+	  a = _toupper(a);
+	  b = _toupper(b);
+	}
+      }
+    }
+  }
 
-  }
+  if (altered && (! (isalpha(a) && isalpha(b)))) {
+    if (a == b)
+      return 1000;
+    else
+      return -1000;
+  }
 
-  return sum;
+  if (a < b) return blosum62(b,a,0,0);
 
-  }
+  if ( a == 'A' && b == 'A' ) return    7;
 
-
+  if ( a == 'B' && b == 'A' ) return   -4;
+  if ( a == 'B' && b == 'B' ) return    7;
 
-/*=====================================================================*/
+  if ( a == 'C' && b == 'A' ) return    0;
+  if ( a == 'C' && b == 'B' ) return   -6;
+  if ( a == 'C' && b == 'C' ) return   17;
 
-/* Returns sum(i=0..n-1, v[i]^2) */
+  if ( a == 'D' && b == 'A' ) return   -4;
+  if ( a == 'D' && b == 'B' ) return    8;
+  if ( a == 'D' && b == 'C' ) return   -6;
+  if ( a == 'D' && b == 'D' ) return   11;
 
-  
+  if ( a == 'E' && b == 'A' ) return   -2;
+  if ( a == 'E' && b == 'B' ) return    2;
+  if ( a == 'E' && b == 'C' ) return   -8;
+  if ( a == 'E' && b == 'D' ) return    4;
+  if ( a == 'E' && b == 'E' ) return    9;
 
-double vsumsqr(double v[],  int n)
+  if ( a == 'F' && b == 'A' ) return   -4;
+  if ( a == 'F' && b == 'B' ) return   -6;
+  if ( a == 'F' && b == 'C' ) return   -4;
+  if ( a == 'F' && b == 'D' ) return   -6;
+  if ( a == 'F' && b == 'E' ) return   -6;
+  if ( a == 'F' && b == 'F' ) return   11;
 
-  {
+  if ( a == 'G' && b == 'A' ) return    0;
+  if ( a == 'G' && b == 'B' ) return   -2;
+  if ( a == 'G' && b == 'C' ) return   -6;
+  if ( a == 'G' && b == 'D' ) return   -2;
+  if ( a == 'G' && b == 'E' ) return   -4;
+  if ( a == 'G' && b == 'F' ) return   -6;
+  if ( a == 'G' && b == 'G' ) return   11;
 
-  double sum;
+  if ( a == 'H' && b == 'A' ) return   -4;
+  if ( a == 'H' && b == 'B' ) return    0;
+  if ( a == 'H' && b == 'C' ) return   -6;
+  if ( a == 'H' && b == 'D' ) return   -2;
+  if ( a == 'H' && b == 'E' ) return    0;
+  if ( a == 'H' && b == 'F' ) return   -2;
+  if ( a == 'H' && b == 'G' ) return   -4;
+  if ( a == 'H' && b == 'H' ) return   15;
 
-  int i; 
+  if ( a == 'I' && b == 'A' ) return   -2;
+  if ( a == 'I' && b == 'B' ) return   -6;
+  if ( a == 'I' && b == 'C' ) return   -2;
+  if ( a == 'I' && b == 'D' ) return   -6;
+  if ( a == 'I' && b == 'E' ) return   -6;
+  if ( a == 'I' && b == 'F' ) return    0;
+  if ( a == 'I' && b == 'G' ) return   -8;
+  if ( a == 'I' && b == 'H' ) return   -6;
+  if ( a == 'I' && b == 'I' ) return    7;
 
-   
+  if ( a == 'K' && b == 'A' ) return   -2;
+  if ( a == 'K' && b == 'B' ) return    0;
+  if ( a == 'K' && b == 'C' ) return   -6;
+  if ( a == 'K' && b == 'D' ) return   -2;
+  if ( a == 'K' && b == 'E' ) return    2;
+  if ( a == 'K' && b == 'F' ) return   -6;
+  if ( a == 'K' && b == 'G' ) return   -4;
+  if ( a == 'K' && b == 'H' ) return   -2;
+  if ( a == 'K' && b == 'I' ) return   -6;
+  if ( a == 'K' && b == 'K' ) return    9;
 
-  sum = DSQR(*v); n--; v++;
+  if ( a == 'L' && b == 'A' ) return   -2;
+  if ( a == 'L' && b == 'B' ) return   -8;
+  if ( a == 'L' && b == 'C' ) return   -2;
+  if ( a == 'L' && b == 'D' ) return   -8;
+  if ( a == 'L' && b == 'E' ) return   -6;
+  if ( a == 'L' && b == 'F' ) return    0;
+  if ( a == 'L' && b == 'G' ) return   -8;
+  if ( a == 'L' && b == 'H' ) return   -6;
+  if ( a == 'L' && b == 'I' ) return    4;
+  if ( a == 'L' && b == 'K' ) return   -4;
+  if ( a == 'L' && b == 'L' ) return    7;
 
-  for (i = 0; i != n; i++, v++) sum += DSQR(*v);
+  if ( a == 'M' && b == 'A' ) return   -2;
+  if ( a == 'M' && b == 'B' ) return   -6;
+  if ( a == 'M' && b == 'C' ) return   -2;
+  if ( a == 'M' && b == 'D' ) return   -6;
+  if ( a == 'M' && b == 'E' ) return   -4;
+  if ( a == 'M' && b == 'F' ) return    0;
+  if ( a == 'M' && b == 'G' ) return   -6;
+  if ( a == 'M' && b == 'H' ) return   -4;
+  if ( a == 'M' && b == 'I' ) return    2;
+  if ( a == 'M' && b == 'K' ) return   -2;
+  if ( a == 'M' && b == 'L' ) return    4;
+  if ( a == 'M' && b == 'M' ) return    9;
 
-  return sum;
+  if ( a == 'N' && b == 'A' ) return   -4;
+  if ( a == 'N' && b == 'B' ) return    6;
+  if ( a == 'N' && b == 'C' ) return   -6;
+  if ( a == 'N' && b == 'D' ) return    2;
+  if ( a == 'N' && b == 'E' ) return    0;
+  if ( a == 'N' && b == 'F' ) return   -6;
+  if ( a == 'N' && b == 'G' ) return    0;
+  if ( a == 'N' && b == 'H' ) return    2;
+  if ( a == 'N' && b == 'I' ) return   -6;
+  if ( a == 'N' && b == 'K' ) return    0;
+  if ( a == 'N' && b == 'L' ) return   -6;
+  if ( a == 'N' && b == 'M' ) return   -4;
+  if ( a == 'N' && b == 'N' ) return   11;
 
-  }
+  if ( a == 'P' && b == 'A' ) return   -2;
+  if ( a == 'P' && b == 'B' ) return   -4;
+  if ( a == 'P' && b == 'C' ) return   -6;
+  if ( a == 'P' && b == 'D' ) return   -2;
+  if ( a == 'P' && b == 'E' ) return   -2;
+  if ( a == 'P' && b == 'F' ) return   -8;
+  if ( a == 'P' && b == 'G' ) return   -4;
+  if ( a == 'P' && b == 'H' ) return   -4;
+  if ( a == 'P' && b == 'I' ) return   -6;
+  if ( a == 'P' && b == 'K' ) return   -2;
+  if ( a == 'P' && b == 'L' ) return   -6;
+  if ( a == 'P' && b == 'M' ) return   -4;
+  if ( a == 'P' && b == 'N' ) return   -4;
+  if ( a == 'P' && b == 'P' ) return   13;
 
-
+  if ( a == 'Q' && b == 'A' ) return   -2;
+  if ( a == 'Q' && b == 'B' ) return    0;
+  if ( a == 'Q' && b == 'C' ) return   -6;
+  if ( a == 'Q' && b == 'D' ) return    0;
+  if ( a == 'Q' && b == 'E' ) return    4;
+  if ( a == 'Q' && b == 'F' ) return   -6;
+  if ( a == 'Q' && b == 'G' ) return   -4;
+  if ( a == 'Q' && b == 'H' ) return    0;
+  if ( a == 'Q' && b == 'I' ) return   -6;
+  if ( a == 'Q' && b == 'K' ) return    2;
+  if ( a == 'Q' && b == 'L' ) return   -4;
+  if ( a == 'Q' && b == 'M' ) return    0;
+  if ( a == 'Q' && b == 'N' ) return    0;
+  if ( a == 'Q' && b == 'P' ) return   -2;
+  if ( a == 'Q' && b == 'Q' ) return    9;
 
-/*=====================================================================*/
+  if ( a == 'R' && b == 'A' ) return   -2;
+  if ( a == 'R' && b == 'B' ) return   -2;
+  if ( a == 'R' && b == 'C' ) return   -6;
+  if ( a == 'R' && b == 'D' ) return   -4;
+  if ( a == 'R' && b == 'E' ) return    0;
+  if ( a == 'R' && b == 'F' ) return   -6;
+  if ( a == 'R' && b == 'G' ) return   -4;
+  if ( a == 'R' && b == 'H' ) return    0;
+  if ( a == 'R' && b == 'I' ) return   -6;
+  if ( a == 'R' && b == 'K' ) return    4;
+  if ( a == 'R' && b == 'L' ) return   -4;
+  if ( a == 'R' && b == 'M' ) return   -2;
+  if ( a == 'R' && b == 'N' ) return    0;
+  if ( a == 'R' && b == 'P' ) return   -4;
+  if ( a == 'R' && b == 'Q' ) return    2;
+  if ( a == 'R' && b == 'R' ) return    9;
 
-/* Returns sum(i=0..n-1, a[3*i]*b[3*i]) */
+  if ( a == 'S' && b == 'A' ) return    2;
+  if ( a == 'S' && b == 'B' ) return    0;
+  if ( a == 'S' && b == 'C' ) return   -2;
+  if ( a == 'S' && b == 'D' ) return    0;
+  if ( a == 'S' && b == 'E' ) return    0;
+  if ( a == 'S' && b == 'F' ) return   -4;
+  if ( a == 'S' && b == 'G' ) return    0;
+  if ( a == 'S' && b == 'H' ) return   -2;
+  if ( a == 'S' && b == 'I' ) return   -4;
+  if ( a == 'S' && b == 'K' ) return    0;
+  if ( a == 'S' && b == 'L' ) return   -4;
+  if ( a == 'S' && b == 'M' ) return   -2;
+  if ( a == 'S' && b == 'N' ) return    2;
+  if ( a == 'S' && b == 'P' ) return   -2;
+  if ( a == 'S' && b == 'Q' ) return    0;
+  if ( a == 'S' && b == 'R' ) return   -2;
+  if ( a == 'S' && b == 'S' ) return    7;
 
-  
+  if ( a == 'T' && b == 'A' ) return    0;
+  if ( a == 'T' && b == 'B' ) return   -2;
+  if ( a == 'T' && b == 'C' ) return   -2;
+  if ( a == 'T' && b == 'D' ) return   -2;
+  if ( a == 'T' && b == 'E' ) return   -2;
+  if ( a == 'T' && b == 'F' ) return   -4;
+  if ( a == 'T' && b == 'G' ) return   -4;
+  if ( a == 'T' && b == 'H' ) return   -4;
+  if ( a == 'T' && b == 'I' ) return   -2;
+  if ( a == 'T' && b == 'K' ) return   -2;
+  if ( a == 'T' && b == 'L' ) return   -2;
+  if ( a == 'T' && b == 'M' ) return   -2;
+  if ( a == 'T' && b == 'N' ) return    0;
+  if ( a == 'T' && b == 'P' ) return   -2;
+  if ( a == 'T' && b == 'Q' ) return   -2;
+  if ( a == 'T' && b == 'R' ) return   -2;
+  if ( a == 'T' && b == 'S' ) return    2;
+  if ( a == 'T' && b == 'T' ) return    9;
 
-double vdotby3(double a[], double b[],  int n)
+  if ( a == 'V' && b == 'A' ) return    0;
+  if ( a == 'V' && b == 'B' ) return   -6;
+  if ( a == 'V' && b == 'C' ) return   -2;
+  if ( a == 'V' && b == 'D' ) return   -6;
+  if ( a == 'V' && b == 'E' ) return   -4;
+  if ( a == 'V' && b == 'F' ) return   -2;
+  if ( a == 'V' && b == 'G' ) return   -6;
+  if ( a == 'V' && b == 'H' ) return   -6;
+  if ( a == 'V' && b == 'I' ) return    6;
+  if ( a == 'V' && b == 'K' ) return   -4;
+  if ( a == 'V' && b == 'L' ) return    2;
+  if ( a == 'V' && b == 'M' ) return    2;
+  if ( a == 'V' && b == 'N' ) return   -6;
+  if ( a == 'V' && b == 'P' ) return   -4;
+  if ( a == 'V' && b == 'Q' ) return   -4;
+  if ( a == 'V' && b == 'R' ) return   -6;
+  if ( a == 'V' && b == 'S' ) return   -4;
+  if ( a == 'V' && b == 'T' ) return    0;
+  if ( a == 'V' && b == 'V' ) return    7;
 
-  {
+  if ( a == 'W' && b == 'A' ) return   -6;
+  if ( a == 'W' && b == 'B' ) return   -8;
+  if ( a == 'W' && b == 'C' ) return   -4;
+  if ( a == 'W' && b == 'D' ) return   -8;
+  if ( a == 'W' && b == 'E' ) return   -6;
+  if ( a == 'W' && b == 'F' ) return    2;
+  if ( a == 'W' && b == 'G' ) return   -4;
+  if ( a == 'W' && b == 'H' ) return   -4;
+  if ( a == 'W' && b == 'I' ) return   -6;
+  if ( a == 'W' && b == 'K' ) return   -6;
+  if ( a == 'W' && b == 'L' ) return   -4;
+  if ( a == 'W' && b == 'M' ) return   -2;
+  if ( a == 'W' && b == 'N' ) return   -8;
+  if ( a == 'W' && b == 'P' ) return   -8;
+  if ( a == 'W' && b == 'Q' ) return   -4;
+  if ( a == 'W' && b == 'R' ) return   -6;
+  if ( a == 'W' && b == 'S' ) return   -6;
+  if ( a == 'W' && b == 'T' ) return   -4;
+  if ( a == 'W' && b == 'V' ) return   -6;
+  if ( a == 'W' && b == 'W' ) return   21;
 
-  double sum;
+  if ( a == 'X' && b == 'A' ) return    0;
+  if ( a == 'X' && b == 'B' ) return   -2;
+  if ( a == 'X' && b == 'C' ) return   -4;
+  if ( a == 'X' && b == 'D' ) return   -2;
+  if ( a == 'X' && b == 'E' ) return   -2;
+  if ( a == 'X' && b == 'F' ) return   -2;
+  if ( a == 'X' && b == 'G' ) return   -2;
+  if ( a == 'X' && b == 'H' ) return   -2;
+  if ( a == 'X' && b == 'I' ) return   -2;
+  if ( a == 'X' && b == 'K' ) return   -2;
+  if ( a == 'X' && b == 'L' ) return   -2;
+  if ( a == 'X' && b == 'M' ) return   -2;
+  if ( a == 'X' && b == 'N' ) return   -2;
+  if ( a == 'X' && b == 'P' ) return   -4;
+  if ( a == 'X' && b == 'Q' ) return   -2;
+  if ( a == 'X' && b == 'R' ) return   -2;
+  if ( a == 'X' && b == 'S' ) return    0;
+  if ( a == 'X' && b == 'T' ) return    0;
+  if ( a == 'X' && b == 'V' ) return   -2;
+  if ( a == 'X' && b == 'W' ) return   -4;
+  if ( a == 'X' && b == 'X' ) return   -2;
 
-  int i; 
+  if ( a == 'Y' && b == 'A' ) return   -4;
+  if ( a == 'Y' && b == 'B' ) return   -6;
+  if ( a == 'Y' && b == 'C' ) return   -4;
+  if ( a == 'Y' && b == 'D' ) return   -6;
+  if ( a == 'Y' && b == 'E' ) return   -4;
+  if ( a == 'Y' && b == 'F' ) return    6;
+  if ( a == 'Y' && b == 'G' ) return   -6;
+  if ( a == 'Y' && b == 'H' ) return    4;
+  if ( a == 'Y' && b == 'I' ) return   -2;
+  if ( a == 'Y' && b == 'K' ) return   -4;
+  if ( a == 'Y' && b == 'L' ) return   -2;
+  if ( a == 'Y' && b == 'M' ) return   -2;
+  if ( a == 'Y' && b == 'N' ) return   -4;
+  if ( a == 'Y' && b == 'P' ) return   -6;
+  if ( a == 'Y' && b == 'Q' ) return   -2;
+  if ( a == 'Y' && b == 'R' ) return   -4;
+  if ( a == 'Y' && b == 'S' ) return   -4;
+  if ( a == 'Y' && b == 'T' ) return   -4;
+  if ( a == 'Y' && b == 'V' ) return   -2;
+  if ( a == 'Y' && b == 'W' ) return    4;
+  if ( a == 'Y' && b == 'X' ) return   -2;
+  if ( a == 'Y' && b == 'Y' ) return   13;
 
-  
+  if ( a == 'Z' && b == 'A' ) return   -2;
+  if ( a == 'Z' && b == 'B' ) return    2;
+  if ( a == 'Z' && b == 'C' ) return   -6;
+  if ( a == 'Z' && b == 'D' ) return    2;
+  if ( a == 'Z' && b == 'E' ) return    8;
+  if ( a == 'Z' && b == 'F' ) return   -6;
+  if ( a == 'Z' && b == 'G' ) return   -4;
+  if ( a == 'Z' && b == 'H' ) return    0;
+  if ( a == 'Z' && b == 'I' ) return   -6;
+  if ( a == 'Z' && b == 'K' ) return    2;
+  if ( a == 'Z' && b == 'L' ) return   -6;
+  if ( a == 'Z' && b == 'M' ) return   -2;
+  if ( a == 'Z' && b == 'N' ) return    0;
+  if ( a == 'Z' && b == 'P' ) return   -2;
+  if ( a == 'Z' && b == 'Q' ) return    6;
+  if ( a == 'Z' && b == 'R' ) return    0;
+  if ( a == 'Z' && b == 'S' ) return    0;
+  if ( a == 'Z' && b == 'T' ) return   -2;
+  if ( a == 'Z' && b == 'V' ) return   -4;
+  if ( a == 'Z' && b == 'W' ) return   -6;
+  if ( a == 'Z' && b == 'X' ) return   -2;
+  if ( a == 'Z' && b == 'Y' ) return   -4;
+  if ( a == 'Z' && b == 'Z' ) return    7;
 
-  sum = (double)(*a) * (double)(*b); n--; a += 3; b += 3;
+  if (a == b)
+    return 0;
+  else
+    return -8;
+} /* blosum62 */
 
-  for (i = 0; i != n; i++, a += 3, b += 3)
+double check_carbonyl(char a, char b) {
+  if (isascii(a) != isascii(b))
+    return -1000;
+  else {
+    if (! isascii(a)) {
+      a = toascii(a);
+      b = toascii(b);
+      if (isalpha(a) != isalpha(b))
+	return -1000;
+    }
+    if (isalpha(a) && isalpha(b)) {
+      if (isupper(a) != isupper(b))
+	return -1000;
+    }
+  }
+  return 0;
+}
 
-    sum += (double)(*a) * (double)(*b);
 
-  return sum;
+/* Compromise between blosum62 and _really_ simpleminded version... - Allen */
 
-  }
+double glyproaln(char a, char b, int altered, int use_carbonyl) {
 
-
+  if (use_carbonyl) {
+    if (isascii(a) != isascii(b))
+      return -1000;
+    else {
+      if (! isascii(a)) {
+	a = toascii(a);
+	b = toascii(b);
+	if (isalpha(a) != isalpha(b))
+	  return -1000;
+      }
+      if (isalpha(a) && isalpha(b)) {
+	if (isupper(a) != isupper(b))
+	  return -1000;
+	else if (islower(a)) {
+	  a = _toupper(a);
+	  b = _toupper(b);
+	}
+      }
+    }
+  }
 
-
+  /* 1.0 for original (addition if identical),
+     8.0 for conversion to positive */
 
-/*=====================================================================*/
+  if (a == b) {
+    if ((altered > 0) && (! isalpha(a)))
+      return 1000;
+    else if (a == 'X')
+      return (1.0+8.0);
+    else if (a == 'G')
+      return (1.0+8.0+12.0);
+    else if (a == 'P')
+      return (1.0+8.0+14.0);
+    else
+      return (1.0+8.0+8.0);
+  } else if (altered && (! (isalpha(a) && isalpha(b))))
+    return -1000;
+  else if ((a == 'G') || (b == 'G'))
+    return 0.0;
+  else if ((a == 'P') || (b == 'P'))
+    return 0.0;
+  else if (((a == 'B') && ((b == 'N') || (b == 'D'))) ||
+	   ((b == 'B') && ((a == 'N') || (a == 'D'))))
+    return (4.0+8.0);
+  else if (((a == 'Z') && ((b == 'Q') || (b == 'E'))) ||
+	   ((b == 'Z') && ((a == 'Q') || (a == 'E'))))
+    return (4.0+8.0);
+  else
+    return 8.0;
+} /* glyproaln */
